# coding: utf-8

"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
from __future__ import absolute_import

import datetime
import atexit
import json
import mimetypes
from multiprocessing.pool import ThreadPool
import os
import re
import tempfile
import sys
import uuid
import logging

# python 2 and python 3 compatibility library
import six
from six.moves.urllib.parse import quote

from pathlib import Path


try:
    import urllib3
except ImportError:
    raise ImportError('Api client requires urllib3.')

from ntnx_clustermgmt_py_client.configuration import Configuration
import ntnx_clustermgmt_py_client.models
from ntnx_clustermgmt_py_client import rest
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiResponseMetadata import ApiResponseMetadata
from ntnx_clustermgmt_py_client.models.common.v1.config.Flag import Flag

PY2 = sys.version_info[0] < 3

logger = logging.getLogger(__name__)

class ApiClient(object):

    """API client to handle the client-server communication, and is invariant across implementations.

    :param configuration: Configuration object for this client
    :type configuration: :class:`~ntnx_vmm_py_client.configuration.Configuration`, required
    """  # noqa: E501

    SDK_VERSION = "v4.1"
    PRIMITIVE_TYPES = (float, bool, bytes, six.text_type) + six.integer_types
    NATIVE_TYPES_MAPPING = {
        'int': int,
        'long': int if six.PY3 else long,  # noqa: F821
        'float': float,
        'str': str,
        'bool': bool,
        'date': datetime.date,
        'datetime': datetime.datetime,
        'object': object,
    }
    DUPLICATE_SCHEMA_MAPPING = {
    # Populated if multiple schemas exist with the same name
        'OneOfclustermgmt.v4.config.DiscoverUnconfiguredNodesApiResponsedata' : 'DiscoverUnconfiguredNodesApiResponsedata',
        'clustermgmt.v4.config.ClusterFunctionRef' : 'ClusterFunctionRef',
        'common.v1.config.FQDN' : 'FQDN',
        'clustermgmt.v4.config.ManagedCluster' : 'ManagedCluster',
        'clustermgmt.v4.config.GetClusterProfileApiResponse' : 'GetClusterProfileApiResponse',
        'common.v1.config.IpRange' : 'IpRange',
        'clustermgmt.v4.config.ListPhysicalGpuProfilesApiResponse' : 'ListPhysicalGpuProfilesApiResponse',
        'OneOfclustermgmt.v4.config.DeleteClusterApiResponsedata' : 'DeleteClusterApiResponsedata',
        'clustermgmt.v4.config.DiskStatus' : 'DiskStatus',
        'OneOfclustermgmt.v4.config.UnregisterVcenterExtensionApiResponsedata' : 'UnregisterVcenterExtensionApiResponsedata',
        'clustermgmt.v4.stats.GetStorageContainerStatsApiResponse' : 'GetStorageContainerStatsApiResponse',
        'clustermgmt.v4.config.NodeStatus' : 'NodeStatus',
        'clustermgmt.v4.config.SystemUserPasswordProjection' : 'SystemUserPasswordProjection',
        'clustermgmt.v4.config.HostNic' : 'HostNic',
        'clustermgmt.v4.config.ProtectionSpec' : 'ProtectionSpec',
        'clustermgmt.v4.config.StorageContainer' : 'StorageContainer',
        'clustermgmt.v4.config.DiskReference' : 'DiskReference',
        'clustermgmt.v4.config.FetchNodeNetworkingDetailsApiResponse' : 'FetchNodeNetworkingDetailsApiResponse',
        'OneOfclustermgmt.v4.config.ListDataStoresByClusterIdApiResponsedata' : 'ListDataStoresByClusterIdApiResponsedata',
        'OneOfclustermgmt.v4.config.CreateSnmpUserApiResponsedata' : 'CreateSnmpUserApiResponsedata',
        'OneOfclustermgmt.v4.error.ErrorResponseerror' : 'ErrorResponseerror',
        'clustermgmt.v4.config.RsyslogNetworkProtocol' : 'RsyslogNetworkProtocol',
        'OneOfclustermgmt.v4.config.UpdateDiskLEDStateTaskResponsedata' : 'UpdateDiskLEDStateTaskResponsedata',
        'clustermgmt.v4.config.AddressType' : 'AddressType',
        'clustermgmt.v4.config.DeleteClusterProfileApiResponse' : 'DeleteClusterProfileApiResponse',
        'OneOfclustermgmt.v4.config.ListHostNicsByHostIdApiResponsedata' : 'ListHostNicsByHostIdApiResponsedata',
        'OneOfclustermgmt.v4.config.UpdateRsyslogServerApiResponsedata' : 'UpdateRsyslogServerApiResponsedata',
        'clustermgmt.v4.config.ExpandClusterApiResponse' : 'ExpandClusterApiResponse',
        'OneOfclustermgmt.v4.config.DeleteSnmpTrapApiResponsedata' : 'DeleteSnmpTrapApiResponsedata',
        'clustermgmt.v4.config.ClearThickProvisionedSpaceApiResponse' : 'ClearThickProvisionedSpaceApiResponse',
        'OneOfclustermgmt.v4.operations.ExitHostMaintenanceApiResponsedata' : 'ExitHostMaintenanceApiResponsedata',
        'common.v1.stats.TimeIntValuePair' : 'TimeIntValuePair',
        'clustermgmt.v4.config.AuthorizedPublicKey' : 'AuthorizedPublicKey',
        'OneOfclustermgmt.v4.stats.GetDiskStatsApiResponsedata' : 'GetDiskStatsApiResponsedata',
        'clustermgmt.v4.ahv.config.ListPcieDevicesApiResponse' : 'ListPcieDevicesApiResponse',
        'clustermgmt.v4.config.DomainAwarenessLevel' : 'DomainAwarenessLevel',
        'clustermgmt.v4.config.ErasureCodeStatus' : 'ErasureCodeStatus',
        'common.v1.config.BasicAuth' : 'BasicAuth',
        'clustermgmt.v4.config.UpdateSnmpStatusApiResponse' : 'UpdateSnmpStatusApiResponse',
        'OneOfclustermgmt.v4.config.ListRackableUnitsByClusterIdApiResponsedata' : 'ListRackableUnitsByClusterIdApiResponsedata',
        'clustermgmt.v4.error.ErrorResponse' : 'ErrorResponse',
        'clustermgmt.v4.ahv.config.PcieDevice' : 'PcieDevice',
        'clustermgmt.v4.config.Disk' : 'Disk',
        'clustermgmt.v4.config.HypervisorReference' : 'HypervisorReference',
        'clustermgmt.v4.config.TaskResponse' : 'TaskResponse',
        'clustermgmt.v4.config.VcenterExtension' : 'VcenterExtension',
        'clustermgmt.v4.config.HypervisorUploadNodeListItem' : 'HypervisorUploadNodeListItem',
        'clustermgmt.v4.config.HostNicProjection' : 'HostNicProjection',
        'clustermgmt.v4.config.NetworkInfo' : 'NetworkInfo',
        'OneOfclustermgmt.v4.config.CreateSnmpTrapApiResponsedata' : 'CreateSnmpTrapApiResponsedata',
        'clustermgmt.v4.config.GpuMode' : 'GpuMode',
        'clustermgmt.v4.config.SoftwareMapReference' : 'SoftwareMapReference',
        'clustermgmt.v4.config.Host' : 'Host',
        'clustermgmt.v4.config.UpdateStorageContainerApiResponse' : 'UpdateStorageContainerApiResponse',
        'clustermgmt.v4.config.CreateClusterApiResponse' : 'CreateClusterApiResponse',
        'clustermgmt.v4.config.NonCompatibleClusterReference' : 'NonCompatibleClusterReference',
        'OneOfclustermgmt.v4.config.ValidateNodeParamspec' : 'ValidateNodeParamspec',
        'clustermgmt.v4.config.RackReference' : 'RackReference',
        'OneOfclustermgmt.v4.config.DeleteClusterProfileApiResponsedata' : 'DeleteClusterProfileApiResponsedata',
        'OneOfclustermgmt.v4.config.AssociateCategoriesToClusterApiResponsedata' : 'AssociateCategoriesToClusterApiResponsedata',
        'clustermgmt.v4.config.ListHostsApiResponse' : 'ListHostsApiResponse',
        'clustermgmt.v4.config.PrivateKeyAlgorithm' : 'PrivateKeyAlgorithm',
        'clustermgmt.v4.config.TaskResponseType' : 'TaskResponseType',
        'clustermgmt.v4.config.HttpProxyWhiteListConfig' : 'HttpProxyWhiteListConfig',
        'clustermgmt.v4.config.HypervisorType' : 'HypervisorType',
        'OneOfclustermgmt.v4.ahv.config.ListPcieDevicesApiResponsedata' : 'ListPcieDevicesApiResponsedata',
        'clustermgmt.v4.config.UplinkInfo' : 'UplinkInfo',
        'clustermgmt.v4.config.SystemType' : 'SystemType',
        'clustermgmt.v4.config.DomainType' : 'DomainType',
        'clustermgmt.v4.config.HypervisorState' : 'HypervisorState',
        'clustermgmt.v4.config.UpdateSSLCertificateApiResponse' : 'UpdateSSLCertificateApiResponse',
        'OneOfclustermgmt.v4.config.UpdateClusterApiResponsedata' : 'UpdateClusterApiResponsedata',
        'clustermgmt.v4.config.SnmpProtocol' : 'SnmpProtocol',
        'OneOfclustermgmt.v4.config.GetHostApiResponsedata' : 'GetHostApiResponsedata',
        'clustermgmt.v4.config.BackplaneNetworkParams' : 'BackplaneNetworkParams',
        'clustermgmt.v4.config.DiscoverUnconfiguredNodesApiResponse' : 'DiscoverUnconfiguredNodesApiResponse',
        'OneOfclustermgmt.v4.config.RegisterVcenterExtensionApiResponsedata' : 'RegisterVcenterExtensionApiResponsedata',
        'clustermgmt.v4.config.BuildInfo' : 'BuildInfo',
        'clustermgmt.v4.config.AddSnmpTransportsApiResponse' : 'AddSnmpTransportsApiResponse',
        'OneOfclustermgmt.v4.config.ListDisksApiResponsedata' : 'ListDisksApiResponsedata',
        'clustermgmt.v4.config.SnmpTrap' : 'SnmpTrap',
        'clustermgmt.v4.config.ClusterConfigReference' : 'ClusterConfigReference',
        'clustermgmt.v4.config.ConfigParams' : 'ConfigParams',
        'clustermgmt.v4.config.ExpandClusterParams' : 'ExpandClusterParams',
        'clustermgmt.v4.config.CreateStorageContainerApiResponse' : 'CreateStorageContainerApiResponse',
        'clustermgmt.v4.config.ListRsyslogServersByClusterIdApiResponse' : 'ListRsyslogServersByClusterIdApiResponse',
        'clustermgmt.v4.config.RsyslogServer' : 'RsyslogServer',
        'clustermgmt.v4.config.CreateSnmpUserApiResponse' : 'CreateSnmpUserApiResponse',
        'clustermgmt.v4.config.ListVirtualGpuProfilesApiResponse' : 'ListVirtualGpuProfilesApiResponse',
        'clustermgmt.v4.config.DeleteRsyslogServerApiResponse' : 'DeleteRsyslogServerApiResponse',
        'clustermgmt.v4.config.GetHostApiResponse' : 'GetHostApiResponse',
        'clustermgmt.v4.config.NodeParam' : 'NodeParam',
        'clustermgmt.v4.config.NsIpPoolType' : 'NsIpPoolType',
        'common.v1.config.KVPair' : 'KVPair',
        'clustermgmt.v4.config.NodeReference' : 'NodeReference',
        'clustermgmt.v4.config.NodeItem' : 'NodeItem',
        'clustermgmt.v4.config.HypervisorUploadInfo' : 'HypervisorUploadInfo',
        'common.v1.config.IPv4Address' : 'IPv4Address',
        'clustermgmt.v4.config.DeleteClusterApiResponse' : 'DeleteClusterApiResponse',
        'common.v1.config.IPv6Address' : 'IPv6Address',
        'clustermgmt.v4.config.DiskAdditionSpec' : 'DiskAdditionSpec',
        'clustermgmt.v4.config.GetSSLCertificateApiResponse' : 'GetSSLCertificateApiResponse',
        'clustermgmt.v4.config.CategoryEntityReferences' : 'CategoryEntityReferences',
        'OneOfclustermgmt.v4.config.UpdateStorageContainerApiResponsedata' : 'UpdateStorageContainerApiResponsedata',
        'OneOfclustermgmt.v4.config.GetStorageContainerApiResponsedata' : 'GetStorageContainerApiResponsedata',
        'clustermgmt.v4.config.HostNameParam' : 'HostNameParam',
        'clustermgmt.v4.stats.HostStatsProjection' : 'HostStatsProjection',
        'OneOfclustermgmt.v4.config.ListSystemUserPasswordsApiResponsedata' : 'ListSystemUserPasswordsApiResponsedata',
        'clustermgmt.v4.config.NodeListNetworkingDetails' : 'NodeListNetworkingDetails',
        'clustermgmt.v4.stats.ClusterStats' : 'ClusterStats',
        'clustermgmt.v4.config.ClusterReference' : 'ClusterReference',
        'clustermgmt.v4.config.EncryptionStatus' : 'EncryptionStatus',
        'clustermgmt.v4.config.ListDisksApiResponse' : 'ListDisksApiResponse',
        'clustermgmt.v4.stats.ClusterStatsProjection' : 'ClusterStatsProjection',
        'OneOfclustermgmt.v4.config.ListVirtualNicsByHostIdApiResponsedata' : 'ListVirtualNicsByHostIdApiResponsedata',
        'OneOfclustermgmt.v4.config.UpdateClusterProfileApiResponsedata' : 'UpdateClusterProfileApiResponsedata',
        'clustermgmt.v4.config.DiskPartitionInfo' : 'DiskPartitionInfo',
        'OneOfclustermgmt.v4.config.ChangeSystemUserPasswordApiResponsedata' : 'ChangeSystemUserPasswordApiResponsedata',
        'clustermgmt.v4.config.UserInfo' : 'UserInfo',
        'OneOfclustermgmt.v4.config.GetSSLCertificateApiResponsedata' : 'GetSSLCertificateApiResponsedata',
        'clustermgmt.v4.config.ProtectedEntity' : 'ProtectedEntity',
        'clustermgmt.v4.config.RackableUnitModel' : 'RackableUnitModel',
        'clustermgmt.v4.config.NodeListItemReference' : 'NodeListItemReference',
        'clustermgmt.v4.config.ClusterNetwork' : 'ClusterNetwork',
        'common.v1.config.MapOfStringWrapper' : 'MapOfStringWrapper',
        'common.v1.config.IPAddressOrFQDN' : 'IPAddressOrFQDN',
        'clustermgmt.v4.config.MountStorageContainerApiResponse' : 'MountStorageContainerApiResponse',
        'clustermgmt.v4.config.NodeResourceConfig' : 'NodeResourceConfig',
        'clustermgmt.v4.config.PartitionType' : 'PartitionType',
        'clustermgmt.v4.operations.EnterHostMaintenanceSpec' : 'EnterHostMaintenanceSpec',
        'clustermgmt.v4.config.ListSystemUserPasswordsApiResponse' : 'ListSystemUserPasswordsApiResponse',
        'OneOfclustermgmt.v4.config.ExpandClusterApiResponsedata' : 'ExpandClusterApiResponsedata',
        'clustermgmt.v4.config.UpdateBmcInfoResponse' : 'UpdateBmcInfoResponse',
        'OneOfclustermgmt.v4.config.UpdateSSLCertificateApiResponsedata' : 'UpdateSSLCertificateApiResponsedata',
        'common.v1.response.ExternalizableAbstractModel' : 'ExternalizableAbstractModel',
        'clustermgmt.v4.config.SoftwareTypeRef' : 'SoftwareTypeRef',
        'clustermgmt.v4.config.UpdateClusterApiResponse' : 'UpdateClusterApiResponse',
        'clustermgmt.v4.config.NameNetworkRef' : 'NameNetworkRef',
        'common.v1.config.Message' : 'Message',
        'clustermgmt.v4.config.BundleParam' : 'BundleParam',
        'clustermgmt.v4.config.SnmpUser' : 'SnmpUser',
        'OneOfclustermgmt.v4.stats.ClusterStatsApiResponsedata' : 'ClusterStatsApiResponsedata',
        'clustermgmt.v4.config.HypervCredentials' : 'HypervCredentials',
        'OneOfclustermgmt.v4.config.GetVcenterExtensionApiResponsedata' : 'GetVcenterExtensionApiResponsedata',
        'clustermgmt.v4.config.ListHostNicsApiResponse' : 'ListHostNicsApiResponse',
        'OneOfclustermgmt.v4.config.DeleteStorageContainerApiResponsedata' : 'DeleteStorageContainerApiResponsedata',
        'clustermgmt.v4.config.NameMacRef' : 'NameMacRef',
        'clustermgmt.v4.config.HttpProxyConfig' : 'HttpProxyConfig',
        'clustermgmt.v4.config.ManagementServerRef' : 'ManagementServerRef',
        'OneOfclustermgmt.v4.config.CheckHypervisorRequirementsApiResponsedata' : 'CheckHypervisorRequirementsApiResponsedata',
        'clustermgmt.v4.config.UnconfiguredNodeAttributeMap' : 'UnconfiguredNodeAttributeMap',
        'OneOfclustermgmt.v4.config.ApplyClusterProfileApiResponsedata' : 'ApplyClusterProfileApiResponsedata',
        'OneOfclustermgmt.v4.stats.GetStorageContainerStatsApiResponsedata' : 'GetStorageContainerStatsApiResponsedata',
        'clustermgmt.v4.stats.TimeValuePair' : 'TimeValuePair',
        'common.v1.config.MessageSeverity' : 'MessageSeverity',
        'clustermgmt.v4.config.AddDiskApiResponse' : 'AddDiskApiResponse',
        'clustermgmt.v4.config.DomainFaultTolerance' : 'DomainFaultTolerance',
        'OneOfclustermgmt.v4.config.DeleteRsyslogServerApiResponsedata' : 'DeleteRsyslogServerApiResponsedata',
        'clustermgmt.v4.config.CheckHypervisorRequirementsApiResponse' : 'CheckHypervisorRequirementsApiResponse',
        'clustermgmt.v4.config.NsServiceEnum' : 'NsServiceEnum',
        'clustermgmt.v4.config.StorageSummaryProjection' : 'StorageSummaryProjection',
        'clustermgmt.v4.config.ControllerVmReference' : 'ControllerVmReference',
        'clustermgmt.v4.config.UplinkNode' : 'UplinkNode',
        'clustermgmt.v4.config.VirtualGpuConfig' : 'VirtualGpuConfig',
        'clustermgmt.v4.config.RedundancyStatusDetails' : 'RedundancyStatusDetails',
        'clustermgmt.v4.config.DataStoreMount' : 'DataStoreMount',
        'clustermgmt.v4.config.UnregisterVcenterExtensionApiResponse' : 'UnregisterVcenterExtensionApiResponse',
        'networking.v4.aws.config.CloudType' : 'CloudType',
        'clustermgmt.v4.config.SnmpAuthType' : 'SnmpAuthType',
        'clustermgmt.v4.config.SmtpServerRef' : 'SmtpServerRef',
        'clustermgmt.v4.config.ComponentType' : 'ComponentType',
        'clustermgmt.v4.config.OnDiskDedup' : 'OnDiskDedup',
        'clustermgmt.v4.config.ListDataStoresByClusterIdApiResponse' : 'ListDataStoresByClusterIdApiResponse',
        'clustermgmt.v4.config.DataStoreUnmount' : 'DataStoreUnmount',
        'clustermgmt.v4.config.HttpProxyWhiteListTargetType' : 'HttpProxyWhiteListTargetType',
        'clustermgmt.v4.stats.DiskStats' : 'DiskStats',
        'clustermgmt.v4.config.ClusterFaultToleranceRef' : 'ClusterFaultToleranceRef',
        'OneOfclustermgmt.v4.config.GetSnmpConfigByClusterIdApiResponsedata' : 'GetSnmpConfigByClusterIdApiResponsedata',
        'clustermgmt.v4.config.GetHostNicApiResponse' : 'GetHostNicApiResponse',
        'clustermgmt.v4.config.GetRackableUnitApiResponse' : 'GetRackableUnitApiResponse',
        'clustermgmt.v4.config.HttpProxyType' : 'HttpProxyType',
        'common.v1.config.TenantAwareModel' : 'TenantAwareModel',
        'clustermgmt.v4.config.BmcInfo' : 'BmcInfo',
        'clustermgmt.v4.config.Cluster' : 'Cluster',
        'OneOfclustermgmt.v4.config.GetRackableUnitApiResponsedata' : 'GetRackableUnitApiResponsedata',
        'clustermgmt.v4.config.ClusterProfileProjection' : 'ClusterProfileProjection',
        'clustermgmt.v4.config.ConfigType' : 'ConfigType',
        'OneOfclustermgmt.v4.config.RemoveSnmpTransportsApiResponsedata' : 'RemoveSnmpTransportsApiResponsedata',
        'OneOfclustermgmt.v4.config.ListPhysicalGpuProfilesApiResponsedata' : 'ListPhysicalGpuProfilesApiResponsedata',
        'clustermgmt.v4.config.NodeDetails' : 'NodeDetails',
        'clustermgmt.v4.config.ChangePasswordSpec' : 'ChangePasswordSpec',
        'clustermgmt.v4.config.GetSnmpConfigByClusterIdApiResponse' : 'GetSnmpConfigByClusterIdApiResponse',
        'clustermgmt.v4.error.AppMessage' : 'AppMessage',
        'clustermgmt.v4.config.GpuType' : 'GpuType',
        'clustermgmt.v4.config.ListRackableUnitsByClusterIdApiResponse' : 'ListRackableUnitsByClusterIdApiResponse',
        'clustermgmt.v4.config.GetSnmpUserApiResponse' : 'GetSnmpUserApiResponse',
        'clustermgmt.v4.operations.TargetRebootDomain' : 'TargetRebootDomain',
        'clustermgmt.v4.config.NonMigratableVmInfo' : 'NonMigratableVmInfo',
        'clustermgmt.v4.config.UplinksField' : 'UplinksField',
        'OneOfclustermgmt.v4.config.RemoveNodeApiResponsedata' : 'RemoveNodeApiResponsedata',
        'clustermgmt.v4.stats.GetDiskStatsApiResponse' : 'GetDiskStatsApiResponse',
        'OneOfclustermgmt.v4.config.ListClusterProfilesApiResponsedata' : 'ListClusterProfilesApiResponsedata',
        'clustermgmt.v4.config.RackableUnitNode' : 'RackableUnitNode',
        'prism.v4.config.TaskReference' : 'TaskReference',
        'clustermgmt.v4.config.UploadInfoNodeItem' : 'UploadInfoNodeItem',
        'OneOfclustermgmt.v4.config.MountStorageContainerApiResponsedata' : 'MountStorageContainerApiResponsedata',
        'clustermgmt.v4.config.CacheDeduplication' : 'CacheDeduplication',
        'OneOfclustermgmt.v4.config.CreateClusterApiResponsedata' : 'CreateClusterApiResponsedata',
        'clustermgmt.v4.config.DeleteStorageContainerApiResponse' : 'DeleteStorageContainerApiResponse',
        'clustermgmt.v4.config.UpdateDiskLEDStateTaskResponse' : 'UpdateDiskLEDStateTaskResponse',
        'clustermgmt.v4.config.GetVcenterExtensionApiResponse' : 'GetVcenterExtensionApiResponse',
        'clustermgmt.v4.config.VcenterInfo' : 'VcenterInfo',
        'clustermgmt.v4.config.RsyslogModuleName' : 'RsyslogModuleName',
        'clustermgmt.v4.config.DiskAdvanceConfig' : 'DiskAdvanceConfig',
        'clustermgmt.v4.config.SmtpType' : 'SmtpType',
        'clustermgmt.v4.stats.StorageContainerStats' : 'StorageContainerStats',
        'clustermgmt.v4.config.UpdateClusterProfileApiResponse' : 'UpdateClusterProfileApiResponse',
        'OneOfclustermgmt.v4.config.ListHostsByClusterIdApiResponsedata' : 'ListHostsByClusterIdApiResponsedata',
        'clustermgmt.v4.config.ListHostNicsByHostIdApiResponse' : 'ListHostNicsByHostIdApiResponse',
        'OneOfclustermgmt.v4.config.ValidateNodeApiResponsedata' : 'ValidateNodeApiResponsedata',
        'OneOfclustermgmt.v4.config.ListVcenterExtensionsApiResponsedata' : 'ListVcenterExtensionsApiResponsedata',
        'clustermgmt.v4.config.DeleteSnmpUserApiResponse' : 'DeleteSnmpUserApiResponse',
        'clustermgmt.v4.config.HypervisorUploadParam' : 'HypervisorUploadParam',
        'clustermgmt.v4.operations.EnterHostMaintenanceApiResponse' : 'EnterHostMaintenanceApiResponse',
        'clustermgmt.v4.error.SchemaValidationErrorMessage' : 'SchemaValidationErrorMessage',
        'OneOfclustermgmt.v4.config.GetClusterProfileApiResponsedata' : 'GetClusterProfileApiResponsedata',
        'clustermgmt.v4.config.NodeDiscoveryParams' : 'NodeDiscoveryParams',
        'clustermgmt.v4.config.ProtectionTarget' : 'ProtectionTarget',
        'clustermgmt.v4.config.ClusterProfile' : 'ClusterProfile',
        'clustermgmt.v4.config.RemoveNodeApiResponse' : 'RemoveNodeApiResponse',
        'clustermgmt.v4.config.Uplinks' : 'Uplinks',
        'clustermgmt.v4.config.PhysicalGpuConfig' : 'PhysicalGpuConfig',
        'clustermgmt.v4.config.UplinkNetworkItem' : 'UplinkNetworkItem',
        'OneOfclustermgmt.v4.config.UpdateSnmpTrapApiResponsedata' : 'UpdateSnmpTrapApiResponsedata',
        'clustermgmt.v4.config.StorageSummary' : 'StorageSummary',
        'clustermgmt.v4.config.ToleranceMessage' : 'ToleranceMessage',
        'clustermgmt.v4.config.CredentialStatus' : 'CredentialStatus',
        'clustermgmt.v4.config.ApplyClusterProfileApiResponse' : 'ApplyClusterProfileApiResponse',
        'clustermgmt.v4.config.AcropolisConnectionState' : 'AcropolisConnectionState',
        'clustermgmt.v4.config.ValidateNodeApiResponse' : 'ValidateNodeApiResponse',
        'OneOfclustermgmt.v4.config.GetSnmpUserApiResponsedata' : 'GetSnmpUserApiResponsedata',
        'clustermgmt.v4.config.NodeInfo' : 'NodeInfo',
        'OneOfclustermgmt.v4.config.AddSnmpTransportsApiResponsedata' : 'AddSnmpTransportsApiResponsedata',
        'clustermgmt.v4.config.CreateSnmpTrapApiResponse' : 'CreateSnmpTrapApiResponse',
        'clustermgmt.v4.config.NodeRemovalParams' : 'NodeRemovalParams',
        'OneOfclustermgmt.v4.config.UpdateSnmpStatusApiResponsedata' : 'UpdateSnmpStatusApiResponsedata',
        'clustermgmt.v4.config.RecoveryInfo' : 'RecoveryInfo',
        'common.v1.response.ApiLink' : 'ApiLink',
        'clustermgmt.v4.config.ChangeSystemUserPasswordApiResponse' : 'ChangeSystemUserPasswordApiResponse',
        'clustermgmt.v4.config.UpgradeStatus' : 'UpgradeStatus',
        'clustermgmt.v4.config.RsyslogModuleItem' : 'RsyslogModuleItem',
        'clustermgmt.v4.config.CreateRsyslogServerApiResponse' : 'CreateRsyslogServerApiResponse',
        'clustermgmt.v4.config.HypervisorIsoMap' : 'HypervisorIsoMap',
        'clustermgmt.v4.config.BundleInfo' : 'BundleInfo',
        'clustermgmt.v4.config.UpdateSnmpUserApiResponse' : 'UpdateSnmpUserApiResponse',
        'OneOfclustermgmt.v4.config.GetVirtualNicApiResponsedata' : 'GetVirtualNicApiResponsedata',
        'clustermgmt.v4.config.VcenterCredentials' : 'VcenterCredentials',
        'OneOfclustermgmt.v4.config.GetRsyslogServerApiResponsedata' : 'GetRsyslogServerApiResponsedata',
        'clustermgmt.v4.config.ClusterProjection' : 'ClusterProjection',
        'clustermgmt.v4.config.IpmiReference' : 'IpmiReference',
        'clustermgmt.v4.config.SnmpPrivType' : 'SnmpPrivType',
        'OneOfclustermgmt.v4.config.FetchTaskApiResponsedata' : 'FetchTaskApiResponsedata',
        'clustermgmt.v4.config.PulseStatus' : 'PulseStatus',
        'clustermgmt.v4.config.ClusterArchReference' : 'ClusterArchReference',
        'clustermgmt.v4.error.SchemaValidationError' : 'SchemaValidationError',
        'OneOfclustermgmt.v4.config.AddDiskApiResponsedata' : 'AddDiskApiResponsedata',
        'OneOfclustermgmt.v4.config.ListStorageContainersApiResponsedata' : 'ListStorageContainersApiResponsedata',
        'clustermgmt.v4.config.RegisterVcenterExtensionApiResponse' : 'RegisterVcenterExtensionApiResponse',
        'clustermgmt.v4.config.ValidateNodeParam' : 'ValidateNodeParam',
        'OneOfclustermgmt.v4.stats.HostStatsApiResponsedata' : 'HostStatsApiResponsedata',
        'clustermgmt.v4.config.DeleteDiskApiResponse' : 'DeleteDiskApiResponse',
        'clustermgmt.v4.config.GetRsyslogServerApiResponse' : 'GetRsyslogServerApiResponse',
        'clustermgmt.v4.config.RackableUnit' : 'RackableUnit',
        'clustermgmt.v4.ahv.config.PcieDeviceConfiguration' : 'PcieDeviceConfiguration',
        'clustermgmt.v4.config.GetBmcInfoResponse' : 'GetBmcInfoResponse',
        'clustermgmt.v4.config.SnmpConfig' : 'SnmpConfig',
        'OneOfclustermgmt.v4.config.GetHostNicApiResponsedata' : 'GetHostNicApiResponsedata',
        'OneOfclustermgmt.v4.config.UnmountStorageContainerApiResponsedata' : 'UnmountStorageContainerApiResponsedata',
        'clustermgmt.v4.config.EncryptionScopeInfo' : 'EncryptionScopeInfo',
        'common.v1.stats.DownSamplingOperator' : 'DownSamplingOperator',
        'clustermgmt.v4.stats.HostStats' : 'HostStats',
        'clustermgmt.v4.ahv.config.PcieDeviceType' : 'PcieDeviceType',
        'clustermgmt.v4.config.UnmountStorageContainerApiResponse' : 'UnmountStorageContainerApiResponse',
        'common.v1.config.Flag' : 'Flag',
        'clustermgmt.v4.stats.HostStatsApiResponse' : 'HostStatsApiResponse',
        'clustermgmt.v4.config.ProtectionInfo' : 'ProtectionInfo',
        'clustermgmt.v4.ahv.config.PcieDeviceState' : 'PcieDeviceState',
        'clustermgmt.v4.config.ComputeNonMigratableVmsSpec' : 'ComputeNonMigratableVmsSpec',
        'clustermgmt.v4.config.RecoveryStatus' : 'RecoveryStatus',
        'OneOfclustermgmt.v4.operations.EnterHostMaintenanceApiResponsedata' : 'EnterHostMaintenanceApiResponsedata',
        'clustermgmt.v4.operations.HostMaintenanceCommonSpec' : 'HostMaintenanceCommonSpec',
        'clustermgmt.v4.stats.StorageContainerStatsProjection' : 'StorageContainerStatsProjection',
        'clustermgmt.v4.config.ListStorageContainersApiResponse' : 'ListStorageContainersApiResponse',
        'clustermgmt.v4.config.EncryptionOptionInfo' : 'EncryptionOptionInfo',
        'clustermgmt.v4.config.SnmpTransport' : 'SnmpTransport',
        'clustermgmt.v4.config.DisassociateCategoriesFromClusterApiResponse' : 'DisassociateCategoriesFromClusterApiResponse',
        'clustermgmt.v4.config.UpdateRsyslogServerApiResponse' : 'UpdateRsyslogServerApiResponse',
        'OneOfclustermgmt.v4.config.GetSnmpTrapApiResponsedata' : 'GetSnmpTrapApiResponsedata',
        'clustermgmt.v4.config.DisassociateClusterFromClusterProfileApiResponse' : 'DisassociateClusterFromClusterProfileApiResponse',
        'clustermgmt.v4.config.LEDStateUpdationSpec' : 'LEDStateUpdationSpec',
        'clustermgmt.v4.config.StorageContainerProjection' : 'StorageContainerProjection',
        'clustermgmt.v4.config.UnconfiguredNodeListItem' : 'UnconfiguredNodeListItem',
        'OneOfclustermgmt.v4.config.CreateClusterProfileApiResponsedata' : 'CreateClusterProfileApiResponsedata',
        'OneOfclustermgmt.v4.config.TaskResponseresponse' : 'TaskResponseresponse',
        'clustermgmt.v4.config.KeyManagementDeviceToCertStatusInfo' : 'KeyManagementDeviceToCertStatusInfo',
        'clustermgmt.v4.config.ClusterConfig' : 'ClusterConfig',
        'clustermgmt.v4.config.RemoveSnmpTransportsApiResponse' : 'RemoveSnmpTransportsApiResponse',
        'clustermgmt.v4.config.BlockItem' : 'BlockItem',
        'clustermgmt.v4.config.HostGpu' : 'HostGpu',
        'clustermgmt.v4.config.SnmpStatusParam' : 'SnmpStatusParam',
        'clustermgmt.v4.config.UpdateSnmpTrapApiResponse' : 'UpdateSnmpTrapApiResponse',
        'clustermgmt.v4.config.GetVirtualNicApiResponse' : 'GetVirtualNicApiResponse',
        'clustermgmt.v4.config.VirtualNic' : 'VirtualNic',
        'clustermgmt.v4.config.ListClusterProfilesApiResponse' : 'ListClusterProfilesApiResponse',
        'OneOfclustermgmt.v4.config.ListHostNicsApiResponsedata' : 'ListHostNicsApiResponsedata',
        'clustermgmt.v4.config.NodeNetworkConfig' : 'NodeNetworkConfig',
        'clustermgmt.v4.config.DeleteSnmpTrapApiResponse' : 'DeleteSnmpTrapApiResponse',
        'OneOfclustermgmt.v4.config.GetClusterApiResponsedata' : 'GetClusterApiResponsedata',
        'clustermgmt.v4.config.ListClustersApiResponse' : 'ListClustersApiResponse',
        'clustermgmt.v4.config.NodeRemovalExtraParam' : 'NodeRemovalExtraParam',
        'clustermgmt.v4.config.NonMigratableVmsResult' : 'NonMigratableVmsResult',
        'common.v1.response.ApiResponseMetadata' : 'ApiResponseMetadata',
        'OneOfclustermgmt.v4.config.ClearThickProvisionedSpaceApiResponsedata' : 'ClearThickProvisionedSpaceApiResponsedata',
        'clustermgmt.v4.config.ListHostsByClusterIdApiResponse' : 'ListHostsByClusterIdApiResponse',
        'clustermgmt.v4.operations.RebootType' : 'RebootType',
        'OneOfclustermgmt.v4.config.DisassociateCategoriesFromClusterApiResponsedata' : 'DisassociateCategoriesFromClusterApiResponsedata',
        'clustermgmt.v4.config.ComputeNodeItem' : 'ComputeNodeItem',
        'clustermgmt.v4.config.DataStore' : 'DataStore',
        'clustermgmt.v4.config.ProtectionState' : 'ProtectionState',
        'OneOfclustermgmt.v4.config.UpdateSnmpUserApiResponsedata' : 'UpdateSnmpUserApiResponsedata',
        'clustermgmt.v4.config.BuildReference' : 'BuildReference',
        'clustermgmt.v4.config.ComponentFaultTolerance' : 'ComponentFaultTolerance',
        'clustermgmt.v4.config.FaultToleranceState' : 'FaultToleranceState',
        'clustermgmt.v4.config.Subnet' : 'Subnet',
        'clustermgmt.v4.config.SSLCertificate' : 'SSLCertificate',
        'OneOfclustermgmt.v4.config.GetBmcInfoResponsedata' : 'GetBmcInfoResponsedata',
        'clustermgmt.v4.config.OperationMode' : 'OperationMode',
        'clustermgmt.v4.config.VirtualGpuProfile' : 'VirtualGpuProfile',
        'clustermgmt.v4.config.SnmpTrapVersion' : 'SnmpTrapVersion',
        'clustermgmt.v4.config.DriveReplacementOption' : 'DriveReplacementOption',
        'OneOfcommon.v1.config.KVPairvalue' : 'KVPairvalue',
        'clustermgmt.v4.config.PublicKey' : 'PublicKey',
        'clustermgmt.v4.config.SystemUserPassword' : 'SystemUserPassword',
        'clustermgmt.v4.config.NodeLuksStatus' : 'NodeLuksStatus',
        'clustermgmt.v4.config.GetStorageContainerApiResponse' : 'GetStorageContainerApiResponse',
        'OneOfclustermgmt.v4.config.ListClustersApiResponsedata' : 'ListClustersApiResponsedata',
        'OneOfclustermgmt.v4.config.ListVirtualGpuProfilesApiResponsedata' : 'ListVirtualGpuProfilesApiResponsedata',
        'OneOfclustermgmt.v4.config.ListRsyslogServersByClusterIdApiResponsedata' : 'ListRsyslogServersByClusterIdApiResponsedata',
        'OneOfclustermgmt.v4.config.ListHostsApiResponsedata' : 'ListHostsApiResponsedata',
        'clustermgmt.v4.config.GetSnmpTrapApiResponse' : 'GetSnmpTrapApiResponse',
        'clustermgmt.v4.stats.ClusterStatsApiResponse' : 'ClusterStatsApiResponse',
        'clustermgmt.v4.config.DigitalCertificateMapReference' : 'DigitalCertificateMapReference',
        'clustermgmt.v4.config.GetClusterApiResponse' : 'GetClusterApiResponse',
        'OneOfclustermgmt.v4.config.DeleteDiskApiResponsedata' : 'DeleteDiskApiResponsedata',
        'clustermgmt.v4.config.PasswordStatus' : 'PasswordStatus',
        'clustermgmt.v4.config.ValidateBundleInfo' : 'ValidateBundleInfo',
        'clustermgmt.v4.config.ClusterReferenceListSpec' : 'ClusterReferenceListSpec',
        'clustermgmt.v4.config.KeyManagementServerType' : 'KeyManagementServerType',
        'clustermgmt.v4.config.NsBackingType' : 'NsBackingType',
        'clustermgmt.v4.config.RecoverySpec' : 'RecoverySpec',
        'clustermgmt.v4.config.MultiDomainFaultToleranceStatus' : 'MultiDomainFaultToleranceStatus',
        'clustermgmt.v4.config.FetchTaskApiResponse' : 'FetchTaskApiResponse',
        'OneOfclustermgmt.v4.config.DisassociateClusterFromClusterProfileApiResponsedata' : 'DisassociateClusterFromClusterProfileApiResponsedata',
        'clustermgmt.v4.config.AttributeItem' : 'AttributeItem',
        'clustermgmt.v4.config.NetworkSwitchInterface' : 'NetworkSwitchInterface',
        'clustermgmt.v4.config.NsServiceStateEnum' : 'NsServiceStateEnum',
        'clustermgmt.v4.config.ListVcenterExtensionsApiResponse' : 'ListVcenterExtensionsApiResponse',
        'clustermgmt.v4.config.ClusterNetworkReference' : 'ClusterNetworkReference',
        'clustermgmt.v4.config.HostTypeEnum' : 'HostTypeEnum',
        'clustermgmt.v4.config.StorageTier' : 'StorageTier',
        'clustermgmt.v4.config.StorageTierReference' : 'StorageTierReference',
        'clustermgmt.v4.config.UnconfigureNodeDetails' : 'UnconfigureNodeDetails',
        'networking.v4.aws.config.AwsSubnet' : 'AwsSubnet',
        'clustermgmt.v4.config.CreateClusterProfileApiResponse' : 'CreateClusterProfileApiResponse',
        'clustermgmt.v4.config.SmtpNetwork' : 'SmtpNetwork',
        'clustermgmt.v4.config.PIIScrubbingLevel' : 'PIIScrubbingLevel',
        'clustermgmt.v4.config.AssociateCategoriesToClusterApiResponse' : 'AssociateCategoriesToClusterApiResponse',
        'clustermgmt.v4.config.RsyslogModuleLogSeverityLevel' : 'RsyslogModuleLogSeverityLevel',
        'OneOfclustermgmt.v4.config.FetchNodeNetworkingDetailsApiResponsedata' : 'FetchNodeNetworkingDetailsApiResponsedata',
        'clustermgmt.v4.config.NodeNetworkingDetails' : 'NodeNetworkingDetails',
        'OneOfclustermgmt.v4.config.CreateRsyslogServerApiResponsedata' : 'CreateRsyslogServerApiResponsedata',
        'OneOfclustermgmt.v4.config.CreateStorageContainerApiResponsedata' : 'CreateStorageContainerApiResponsedata',
        'clustermgmt.v4.operations.ExitHostMaintenanceApiResponse' : 'ExitHostMaintenanceApiResponse',
        'common.v1.config.IPAddress' : 'IPAddress',
        'clustermgmt.v4.config.GetDiskApiResponse' : 'GetDiskApiResponse',
        'OneOfclustermgmt.v4.config.GetDiskApiResponsedata' : 'GetDiskApiResponsedata',
        'OneOfclustermgmt.v4.config.UpdateBmcInfoResponsedata' : 'UpdateBmcInfoResponsedata',
        'clustermgmt.v4.operations.RollingRebootParams' : 'RollingRebootParams',
        'clustermgmt.v4.config.ListVirtualNicsByHostIdApiResponse' : 'ListVirtualNicsByHostIdApiResponse',
        'clustermgmt.v4.config.ManagementServerType' : 'ManagementServerType',
        'OneOfclustermgmt.v4.config.DeleteSnmpUserApiResponsedata' : 'DeleteSnmpUserApiResponsedata',
        'clustermgmt.v4.config.PhysicalGpuProfile' : 'PhysicalGpuProfile'
    }

    def __init__(self, configuration=None):
        if configuration is None:
            configuration = Configuration()
        self.configuration = configuration

        self.__pool = None

        self.rest_client = rest.RESTClientObject(configuration, max_retry_attempts=configuration.max_retry_attempts, backoff_factor=configuration.backoff_factor)
        self.__default_headers = {}

        self.__cookie = None
        self.__refresh_cookie = True


    def __close(self):
        if self.__pool:
            self.__pool.close()
            self.__pool.join()
            self.__pool = None
            if hasattr(atexit, 'unregister'):
                atexit.unregister(self.__close)

            logger.info("Thread pool closed")

    def __initialize_threadpool(self):
        if not self.__pool:
            logger.info("Initializing the thread pool")
            self.__pool = ThreadPool()
            atexit.register(self.__close)

    def add_default_header(self, header_name, header_value):
        """Add a default header to be included in each HTTP request.

        :param header_name: Name of a default header
        :type header_name: :class:`str`
        :param header_value: Value of the provided default header
        :type header_value: :class:`str`
        """
        if header_name == 'Authorization':
            self.__cookie = None

        self.__default_headers[header_name] = header_value

    def __get_request_timeout(self, request_timeout):
        """Gets the Request timeout in seconds.

        :param request_timeout: A list of integers for the [connect, read] timeouts in milliseconds for an operation
        :type request_timeout: :class:`list`
        :return: A final list of integers for the [connect, read] timeouts in milliseconds for an operation
        :rtype: :class:`list`
        """

        if not request_timeout or not isinstance(request_timeout, list) or len(request_timeout) != 2:
            request_timeout = []
            request_timeout.append(self.__get_valid_timeout(self.configuration.connect_timeout, self.configuration.default_connect_timeout))
            request_timeout.append(self.__get_valid_timeout(self.configuration.read_timeout, self.configuration.default_read_timeout))
            return request_timeout
        else:
            # Handle connect timeout
            connect_configuration_timeout_in_seconds = self.__get_valid_timeout(self.configuration.connect_timeout, self.configuration.default_connect_timeout)
            request_timeout[0] = self.__get_valid_timeout(request_timeout[0], connect_configuration_timeout_in_seconds * 1000)
            # Handle read timeout
            read_configuration_timeout_in_seconds = self.__get_valid_timeout(self.configuration.read_timeout, self.configuration.default_read_timeout)
            request_timeout[1] = self.__get_valid_timeout(request_timeout[1], read_configuration_timeout_in_seconds * 1000)
            return request_timeout

    def __get_valid_timeout(self, timeout, default_timeout):
        if not timeout or not isinstance(timeout, (int, float) if six.PY3 else (int, long, float)):  # noqa: E501,F821
            return default_timeout / 1000

        max_timeout_in_milliseconds = 180 * 60 * 1000  # 180 minutes or 3 hours
        if timeout <= 0:
            timeout = default_timeout
        elif timeout > max_timeout_in_milliseconds:
            timeout = max_timeout_in_milliseconds

        return timeout / 1000


    def __update_cookies(self, response_data):
        # Set Cookie information to reuse in subsequent requests for a valid response
        cookies = response_data.getheader('Set-Cookie')
        if cookies is not None:
            cookie = ''
            cookies_list = cookies.split(',')
            for i in range(0, len(cookies_list)):
                final_cookie = cookies_list[i].split(';', 1)[0]
                final_cookie = final_cookie.strip() if '=' in final_cookie else ''
                if final_cookie:
                    cookie += final_cookie + ';'

            # Remove trailing ";"
            if cookie:
                cookie = cookie[:-1]

            self.__cookie = cookie
            self.__refresh_cookie = False
            logger.debug("Retained cookie: %s", cookie)

    def __call_api(
            self, resource_path, method, path_params=None,
            query_params=None, header_params=None, body=None, post_params=None,
            files=None, response_type=None, auth_settings=None,
            _return_http_data_only=None, collection_formats=None,
            _preload_content=True, _request_timeout=None):

        config = self.configuration

        # Add User-Agent header from configuration
        if config.user_agent:
            self.add_default_header('User-Agent', config.user_agent)

        # header parameters
        header_params = header_params or {}
        header_params.update(self.__default_headers)

        # requestID for idempotence functionality
        if 'NTNX-Request-Id' not in header_params :
            requestId = str(uuid.uuid4())
            header_params['NTNX-Request-Id'] = requestId

        if body and hasattr(body, "get_reserved") and 'ETag' in body.get_reserved():
            header_params['If-Match'] = body.get_reserved()['ETag']

        if self.__cookie:
            header_params['Cookie'] = self.__cookie
            if "Authorization" in header_params:
                header_params.pop("Authorization")
        else :
            self.__update_params_for_auth(header_params, query_params, auth_settings)

        if header_params:
            header_params = self.__sanitize_for_serialization(header_params)
            header_params = dict(self.__parameters_to_tuples(header_params, collection_formats))

        # path parameters
        if path_params:
            path_params = self.__sanitize_for_serialization(path_params)
            path_params = self.__parameters_to_tuples(path_params,
                                                    collection_formats)
            for k, v in path_params:
                # specified safe chars, encode everything
                resource_path = resource_path.replace(
                    '{%s}' % k,
                    quote(str(v), safe=config.safe_chars_for_path_param)
                )

        # query parameters
        if query_params:
            query_params = self.__sanitize_for_serialization(query_params)
            query_params = self.__parameters_to_tuples(query_params, collection_formats)

        # post parameters
        if post_params or files:
            post_params = self.__prepare_post_parameters(post_params, files)
            post_params = self.__sanitize_for_serialization(post_params)
            post_params = self.__parameters_to_tuples(post_params, collection_formats)

        # body
        if body and 'application/octet-stream' not in header_params['Content-Type']:
            body = self.__sanitize_for_serialization(body)

        # request url
        url = config.scheme + '://' + config.host + ':' + str(config.port) + resource_path

        # perform request and return response
        response_data = self.request(
            method, url, query_params=query_params, headers=header_params,
            post_params=post_params, body=body,
            _preload_content=_preload_content,
            _request_timeout=_request_timeout)

        # Retry one more time for 401 response with basic auth header and no cookie
        if response_data.status == 401:
            logger.debug("Retrying for an unauthorized request")
            self.__refresh_cookie = True
            if 'Cookie' in header_params:
                header_params.update(self.__default_headers)
                header_params.pop('Cookie')
                self.__update_params_for_auth(header_params, query_params, auth_settings)

            response_data = self.request(
                method, url, query_params=query_params, headers=header_params,
                post_params=post_params, body=body,
                _preload_content=_preload_content,
                _request_timeout=_request_timeout)

            # Raise error if 401 persists
            if response_data.status == 401:
                raise ntnx_clustermgmt_py_client.rest.ApiException(http_resp=response_data)

        if self.__refresh_cookie:
            self.__update_cookies(response_data)

        self.last_response = response_data
        return_data = response_data

        # deserialize response data
        try:
            if response_data.status != 204:
                # Download a file
                if response_data.getheader(name='Content-Type') in ['application/octet-stream', 'application/pdf', 'application/zip']:
                    download_path = self.__deserialize_file(response_data)
                    download_path = Path(download_path)

                    # convert response type to class
                    response_type = self.__getattr(response_type)
                    flag = Flag(name="hasError", value=False)
                    metadata = ApiResponseMetadata(flags=[flag])
                    data = {"path": download_path}
                    data["$objectType"] = "pathlib.Path"
                    data["$reserved"] = {}
                    data["$unknownFields"] = {}
                    return response_type(data=data, metadata=metadata)

                # Handle text response
                elif response_data.getheader(name='Content-Type') in ['text/event-stream', 'text/html', 'text/xml', 'text/csv', 'text/javascript', 'text/markdown', 'text/vcard']:
                    # convert response type to class
                    response_type = self.__getattr(response_type)
                    flag = Flag(name="hasError", value=False)
                    metadata = ApiResponseMetadata(flags=[flag])
                    data = response_data.urllib3_response.data
                    return response_type(data=data, metadata=metadata)

                else:
                    # Read the data from original urllib3 response
                    response_data.data = response_data.urllib3_response.data
                    # In the python 3, the response.data is bytes which needs to be decoded to string.
                    if six.PY3:
                        response_data.data = response_data.data.decode('utf-8')

                    return_data = json.loads(response_data.data)
                    return_data = self.__add_header_to_reserved(response_data, return_data, "ETag")
                    if response_type is None and "$objectType" in return_data:
                        response_type = return_data.get("$objectType")
                    if PY2:
                        inner_response_type = response_type.encode('utf-8', 'ignore')
                    else:
                        inner_response_type = response_type

                    return self.deserialize(return_data, inner_response_type)
            else:
                return_data = None
        finally:
            response_data.urllib3_response.drain_conn()
            response_data.urllib3_response.release_conn()
        if _return_http_data_only:
            return (return_data)
        else:
            return (return_data, response_data.status,
                    response_data.getheaders())
    def __sanitize_for_serialization(self, obj):
        """Builds a JSON POST object.

        :param obj: The object to sanitize
        :type obj: :class:`object`
        :return:
        The sanitized object with the following behavior::

            If obj is None, return None.
            If obj is str, int, long, float, bool, return directly.
            If obj is datetime.datetime or datetime.date, convert to string in ISO8601 format.
            If obj is list, sanitize each element in the list.
            If obj is dict, return the dict.
            If obj is a model, return the properties dictionary.
        :rtype: :class:`object`
        """  # noqa: E501
        if obj is None:
            return None
        elif isinstance(obj, self.PRIMITIVE_TYPES):
            return obj
        elif isinstance(obj, list):
            return [self.__sanitize_for_serialization(sub_obj)
                    for sub_obj in obj]
        elif isinstance(obj, tuple):
            return tuple(self.__sanitize_for_serialization(sub_obj)
                         for sub_obj in obj)
        elif isinstance(obj, (datetime.datetime, datetime.date)):
            return obj.isoformat()
        if isinstance(obj, dict):
            obj_dict = obj
        else:
            # Convert model obj to dict except
            # attributes `swagger_types`, `attribute_map`
            # and attributes which value is not None.
            # Convert attribute name to json key in
            # model definition for request.
            obj_dict = {obj.attribute_map[attr]: getattr(obj, attr)
                        for attr, _ in six.iteritems(obj.swagger_types)
                        if getattr(obj, attr) is not None}
        return {key: self.__sanitize_for_serialization(val)
                for key, val in six.iteritems(obj_dict)}

    def __deserialize_response(self, response, response_type):
        """Deserializes response into an object based on the provided response type.

        :param response: A response object to be deserialized
        :type response: :class:`~ntnx_clustermgmt_py_client.rest.RESTResponse`, required
        :param response_type: A class literal for deserialized object, or string of class name
        :type response_type: required
        :return: Deserialized object
        :rtype: :class:`object`
        """  # noqa: E501

        # handle file downloading
        # save response body into a tmp file and return the instance
        if response_type == "file":
            return self.__deserialize_file(response)
        # fetch data from response object
        try:
            data = json.loads(response.data)
        except ValueError:
            data = response.data
        return self.deserialize(data, response_type)

    def deserialize(self, data, klass, discriminator = None):
        """Deserializes dict, list, str into an object.

        :param data: dict, list or str
        :param klass: class literal, or string of class name
        :param discriminator: Deprecated: Discriminator to deserialize into specific model object for a oneOf object. This is no longer needed and will be removed from the method definition soon.
        :type discriminator: :class:`str`
        :return: Deserialized object
        :rtype: :class:`object`
        """  # noqa: E501
        if data is None:
            return None
        if type(klass) == str:
            if klass == 'pathlib.Path':
                data['path'] = Path(data['path'])
                return data
            if klass.startswith('list['):
                sub_kls = re.match(r'list\[(.*)\]', klass).group(1)
                return [self.deserialize(sub_data, sub_kls)
                        for sub_data in data]
            if klass.startswith('dict('):
                sub_kls = re.match(r'dict\(([^,]*), (.*)\)', klass).group(2)
                return {str(k): self.deserialize(v, sub_kls)
                        for k, v in six.iteritems(data)}
            # convert str to class
            if klass in self.NATIVE_TYPES_MAPPING:
                klass = self.NATIVE_TYPES_MAPPING[klass]
            else:
                klass = self.__getattr(klass)
        if klass in self.PRIMITIVE_TYPES:
            return self.__deserialize_primitive(data, klass)
        elif klass == object:
            return self.__deserialize_object(data)
        elif klass == datetime.date:
            return self.__deserialize_date(data)
        elif klass == datetime.datetime:
            return self.__deserialize_datatime(data)
        else:
            return self.__deserialize_model(data, klass)

    def _call_api(self, resource_path, method,
                 path_params=None, query_params=None, header_params=None,
                 body=None, post_params=None, files=None,
                 response_type=None, auth_settings=None, async_req=None,
                 _return_http_data_only=None, collection_formats=None,
                 _preload_content=True, _request_timeout=None):
        """Makes the HTTP request (synchronous) and returns deserialized data. To make an asynchronous request, set the async_req to True.

        :param resource_path: Path to API endpoint
        :type resource_path: :class:`str`, required
        :param method: HTTP method name
        :type method: :class:`str`, required
        :param path_params: A dictionary of path parameters in the url
        :type path_params: :class:`dict`
        :param query_params: A list of tuples denoting query parameters in the url
        :type query_params: :class:`list`
        :param header_params: A dictionary of header parameters to be placed in request headers
        :type header_params: :class:`dict`
        :param body: Request body
        :param post_params: Request's form parameters for application/x-www-form-urlencoded or multipart/form-data content type
        :type post_params: :class:`str`
        :param files: A dictionary in {key -> filename, value -> filepath} format for multipart/form-data.
        :type files: :class:`dict`
        :param response_type: Response data type
        :type response_type: :class:`str`
        :param auth_settings: A list of auth settings names for the request. The following values are accepted currently: ::

            ['apiKeyAuthScheme', 'basicAuthScheme']
        :type auth_settings: :class:`list`
        :param async_req: A flag to toggle between synchronous/asynchronous connection for HTTP request (**Default** False)
        :type async_req: :class:`bool`
        :param _return_http_data_only: A flag to retrurn response data without the status code and response headers
        :type _return_http_data_only: :class:`bool`
        :param collection_formats: A dictionary of collection formats for path, query, header, and post parameters
        :type collection_formats: :class:`dict`
        :param _preload_content: If False, the urllib3.HTTPResponse object will be returned without reading/decoding response data (**Default** True)
        :type _preload_content: :class:`bool`
        :param _request_timeout: Timeout setting for this request. It needs to be a pair (list) of
            [connect, read] timeouts. If invalid list length or type provided,
            the timeouts will be derived from the :class:`~ntnx_clustermgmt_py_client.configuration.Configuration`.
        :type _request_timeout: :class:`list`
        :return: If async_req parameter is True, the request will be called asynchronously and returns the request thread.
            If async_req is False or missing, then the method will return the deserialized response.
        """
        if not async_req:
            return self.__call_api(resource_path, method,
                                   path_params, query_params, header_params,
                                   body, post_params, files,
                                   response_type, auth_settings,
                                   _return_http_data_only, collection_formats,
                                   _preload_content, _request_timeout)
        else:
            self.__initialize_threadpool()
            thread = self.__pool.apply_async(self.__call_api, (resource_path,
                                           method, path_params, query_params,
                                           header_params, body,
                                           post_params, files,
                                           response_type, auth_settings,
                                           _return_http_data_only,
                                           collection_formats,
                                           _preload_content, _request_timeout))
            return thread

    def request(self, method, url, query_params=None, headers=None,
                post_params=None, body=None, _preload_content=True,
                _request_timeout=None):
        client_request_timeout = self.__get_request_timeout(_request_timeout)

        """Makes the HTTP request using RESTClient."""
        if method == "GET":
            return self.rest_client.GET(url,
                                        query_params=query_params,
                                        _preload_content=_preload_content,
                                        _request_timeout=client_request_timeout,
                                        headers=headers)
        elif method == "HEAD":
            return self.rest_client.HEAD(url,
                                         query_params=query_params,
                                         _preload_content=_preload_content,
                                         _request_timeout=client_request_timeout,
                                         headers=headers)
        elif method == "OPTIONS":
            return self.rest_client.OPTIONS(url,
                                            query_params=query_params,
                                            headers=headers,
                                            post_params=post_params,
                                            _preload_content=_preload_content,
                                            _request_timeout=client_request_timeout,
                                            body=body)
        elif method == "POST":
            return self.rest_client.POST(url,
                                         query_params=query_params,
                                         headers=headers,
                                         post_params=post_params,
                                         _preload_content=_preload_content,
                                         _request_timeout=client_request_timeout,
                                         body=body)
        elif method == "PUT":
            return self.rest_client.PUT(url,
                                        query_params=query_params,
                                        headers=headers,
                                        post_params=post_params,
                                        _preload_content=_preload_content,
                                        _request_timeout=client_request_timeout,
                                        body=body)
        elif method == "PATCH":
            return self.rest_client.PATCH(url,
                                          query_params=query_params,
                                          headers=headers,
                                          post_params=post_params,
                                          _preload_content=_preload_content,
                                          _request_timeout=client_request_timeout,
                                          body=body)
        elif method == "DELETE":
            return self.rest_client.DELETE(url,
                                           query_params=query_params,
                                           headers=headers,
                                           _preload_content=_preload_content,
                                           _request_timeout=client_request_timeout,
                                           body=body)
        else:
            error_message = "http method must be `GET`, `HEAD`, `OPTIONS`, `POST`, `PATCH`, `PUT` or `DELETE`."
            logger.error(error_message)
            raise ValueError(error_message)

    def __parameters_to_tuples(self, params, collection_formats):
        """Get parameters as list of tuples, formatting collections.

        :param params: Parameters as dict or list of two-tuples
        :type params: :class:`dict`
        :param collection_formats: Parameter collection formats
        :type collection_formats: :class:`dict`
        :returns: Parameters as list of tuples, collections formatted
        """  # noqa: E501

        new_params = []
        if collection_formats is None:
            collection_formats = {}
        for k, v in six.iteritems(params) if isinstance(params, dict) else params:  # noqa: E501
            if k in collection_formats:
                collection_format = collection_formats[k]
                if collection_format == 'multi':
                    new_params.extend((k, value) for value in v)
                else:
                    if collection_format == 'ssv':
                        delimiter = ' '
                    elif collection_format == 'tsv':
                        delimiter = '\t'
                    elif collection_format == 'pipes':
                        delimiter = '|'
                    else:  # csv is the default
                        delimiter = ','
                    new_params.append(
                        (k, delimiter.join(str(value) for value in v)))
            else:
                new_params.append((k, v))
        return new_params

    def __prepare_post_parameters(self, post_params=None, files=None):
        """Builds form parameters.

        :param post_params: Normal form parameters
        :param files: File parameters
        :return: Form parameters with files
        """  # noqa: E501

        params = []
        if post_params:
            params = post_params
        if files:
            for k, v in six.iteritems(files):
                if not v:
                    continue
                file_names = v if type(v) is list else [v]
                for n in file_names:
                    with open(n, 'rb') as f:
                        filename = os.path.basename(f.name)
                        filedata = f.read()
                        mimetype = (mimetypes.guess_type(filename)[0] or
                                    'application/octet-stream')
                        params.append(
                            tuple([k, tuple([filename, filedata, mimetype])]))
        return params

    def _select_header_accept(self, accepts):
        """Returns `Accept` based on an array of headers provided.

        :param accepts: List of headers
        :type accepts: :class:`list`
        :return: If application/json is available, returns that.
            Otherwise, returns a comma separated string of all the provided Accept types
        """  # noqa: E501

        if not accepts:
            return

        accepts = [x.lower() for x in accepts]
        return ', '.join(accepts)

    def _select_header_content_type(self, content_types):
        """Returns `Content-Type` based on an array of content_types provided.

        :param content_types: List of content-types
        :type content_types: :class:`list`
        :return: Content-Type (e.g. application/json)
        """  # noqa: E501

        if not content_types:
            return 'application/json'
        content_types = [x.lower() for x in content_types]
        if 'application/json' in content_types or '*/*' in content_types:
            return 'application/json'
        else:
            return content_types[0]

    def __update_params_for_auth(self, headers, queries, auth_settings):
        """Updates header and query params based on authentication setting.

        :param headers: Header parameters dict to be updated.
        :param queries: Query parameters tuple list to be updated.
        :param auth_settings: Authentication setting identifiers list.
        """  # noqa: E501
        if not auth_settings:
            return

        for auth in auth_settings:
            auth_setting = self.configuration._auth_settings().get(auth)
            if auth_setting:
                headers.pop(auth_setting['key'], None)

                if not auth_setting['value']:
                    continue
                elif auth_setting['in'] == 'header':
                    headers[auth_setting['key']] = auth_setting['value']
                elif auth_setting['in'] == 'query':
                    queries.append((auth_setting['key'], auth_setting['value']))
                else:
                    error_message = 'Authentication token must be in `query` or `header`'
                    logger.error(error_message)
                    raise ValueError(error_message)

    @staticmethod
    def get_etag(object):
        """Method to extract ETag from an object if exists

        The ETag is usually provided in the response of the GET API calls which can further be used in other HTTP operations.

        :param object: The object from which etag needs to be fetched
        :type object: :class:`object`
        :return: ETag header value for the object
        :rtype: :class:`str` or :class:`None`
        """  # noqa: E501
        etag = None
        if object:
            if hasattr(object, "get_reserved") and 'ETag' in object.get_reserved():
                etag = ApiClient.get_value_for_case_insensitive_key_match(object.get_reserved(), 'ETag')

            if not etag and hasattr(object, "data") and hasattr(object.data, "get_reserved") and 'ETag' in object.data.get_reserved():
                etag = ApiClient.get_value_for_case_insensitive_key_match(object.data.get_reserved(), 'ETag')

        return etag

    @staticmethod
    def get_value_for_case_insensitive_key_match(object, key):
        if object and key:
            key = key.lower()
            for k in object:
                if k.lower() == key:
                    return object[k]

    def __add_header_to_reserved(self, response_data, return_data, key):
        if hasattr(response_data, "getheaders") and key in response_data.getheaders():
            header_val = response_data.getheader(key)
            if "data" in return_data.keys():
                if isinstance(return_data["data"], list) and len(return_data["data"])>0:
                    for item in return_data["data"]:
                        if isinstance(item, dict) and "$reserved" in item.keys():
                            item["$reserved"][key] = header_val
                elif isinstance(return_data["data"], dict) and "$reserved" in return_data["data"].keys():
                    return_data["data"]["$reserved"][key] = header_val
        return return_data

    def __deserialize_file(self, response):
        """Deserializes body to file

        Saves response body into a file in a temporary folder, using the filename from the `Content-Disposition` header if provided.

        :param response: :class:`~ntnx_clustermgmt_py_client.rest.RESTResponse`
        :return: File path
        """

        path = ''
        content_disposition = response.getheader("Content-Disposition")
        if content_disposition:
            filename = re.search(r'filename=[\'"]?([^\'"*]+)[\'"]?', content_disposition).group(1)
            path = os.path.join(self.configuration.download_directory, filename)
        else:
            fd, path = tempfile.mkstemp(dir=self.configuration.download_directory)
            os.close(fd)

        path_tup = os.path.splitext(path)
        timestring = datetime.datetime.now().strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3]
        path = "%s_%s%s" % (path_tup[0], timestring, path_tup[1])
        logger.info('Writing response data to file at %s' % path)
        with open(path, "wb") as f:
            if isinstance(response.urllib3_response, urllib3.response.HTTPResponse):
                for chunk in response.urllib3_response.stream(self.configuration.download_chunk_size):
                    f.write(chunk)

        return path

    def __deserialize_primitive(self, data, klass):
        """Deserializes string to primitive type.

        :param data:
        :type data: :class:`str`
        :param klass: class literal
        :return: :class:`int` or :class:`long` or :class:`float` or :class:`str` or :class:`bool` value
        """

        try:
            return klass(data)
        except UnicodeEncodeError:
            return six.text_type(data)
        except TypeError:
            return data

    def __deserialize_object(self, value):
        """Return a original value.
        :return: :class:`object`
        """
        return value

    def __deserialize_date(self, string):
        """Deserializes string to date.
        :param string:
        :type string: str
        :raises :class:`~ntnx_clustermgmt_py_client.rest.ApiException` if provided string is not a valid date
        :return: date object
        """

        if type(string) == datetime.date:
            return string

        try:
            from dateutil.parser import parse
            return parse(string).date()
        except ImportError:
            return string
        except ValueError:
            raise rest.ApiException(
                status=0,
                reason="Failed to parse `{0}` as date object".format(string)
            )

    def __deserialize_datatime(self, string):
        """Deserializes string to datetime.

        The string should be in ISO8601 datetime format.

        :param string:
        :type string: :class:`str`
        :raises :class:`~ntnx_clustermgmt_py_client.rest.ApiException` if provided string is not a valid datetime
        :return: :class:`datetime`
        """

        if type(string) == datetime.datetime:
            return string

        try:
            from dateutil.parser import parse
            return parse(string)
        except ImportError:
            return string
        except ValueError:
            raise rest.ApiException(
                status=0,
                reason=(
                    "Failed to parse `{0}` as datetime object"
                    .format(string)
                )
            )

    def __hasattr(self, object, name):
            return name in object.__class__.__dict__

    def __getattr(self, name):
        if name in self.DUPLICATE_SCHEMA_MAPPING:
            return getattr(ntnx_clustermgmt_py_client.models, self.DUPLICATE_SCHEMA_MAPPING[name])
        if hasattr(ntnx_clustermgmt_py_client.models, name.split('.')[-1]):
            return getattr(ntnx_clustermgmt_py_client.models, name.split('.')[-1])
        else:
            return getattr(ntnx_clustermgmt_py_client.models, name)

    def __deserialize_model(self, data, klass):
        """Deserializes list or dict to model.
        :param data:
        :type data: :class:`dict`, :class:`list`
        :param klass: class literal
        :return: Model object
        """

        if not hasattr(klass, 'swagger_types') and not self.__hasattr(klass, 'get_real_child_model'):
            return data
        kwargs = {}
        if klass.swagger_types is not None:
            for attr, attr_type in six.iteritems(klass.swagger_types):
                if data is not None and isinstance(data, (list, dict)):
                    value = None
                    if klass.attribute_map[attr] in data:
                        value = data[klass.attribute_map[attr]]
                        data.pop(klass.attribute_map[attr])
                    elif attr in data:
                        value = data[attr]
                        data.pop(attr)

                    one_of_value = None
                    if attr_type.startswith('OneOf'):
                        if type(value) is list:
                            one_of_value = []
                            # OneOf of list type can have list of objects or list of primitive types
                            for value_item in value:
                                if type(value_item) is not dict:
                                    one_of_value.append(self.deserialize(value_item, type(value_item)))
                                else:
                                    one_of_value.append(self.deserialize(value_item, self.__getattr(value_item['$objectType'])))
                        elif type(value) is dict:
                            # OneOf of dict type can be a single response object or a map of primitive types
                            if '$objectType' in value:
                                one_of_value = self.deserialize(value, value['$objectType']
                                    if value['$objectType'] == 'pathlib.Path' else self.__getattr(value['$objectType']))
                            else:
                                one_of_value = {}
                                for item_key, item_value in six.iteritems(value):
                                    one_of_value[item_key] = self.deserialize(item_value, type(item_value))
                        else:
                            one_of_value = value

                    kwargs[attr] = self.deserialize(value, attr_type) if one_of_value is None else one_of_value

            if "_unknown_fields" in klass.swagger_types:
                if "_unknown_fields" not in kwargs or kwargs["_unknown_fields"] is None:
                    kwargs["_unknown_fields"] = {}
                for key, value in data.items():
                    if value is not None:
                        kwargs["_unknown_fields"][key] = value

        instance = klass(**kwargs)
        if (isinstance(instance, dict) and
                klass.swagger_types is not None and
                isinstance(data, dict)):
            for key, value in data.items():
                if key not in klass.swagger_types:
                    instance[key] = value

        return instance
