# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.ahv.config.PcieDeviceConfiguration import PcieDeviceConfiguration  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.ahv.config.PcieDeviceState import PcieDeviceState  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.ahv.config.PcieDeviceType import PcieDeviceType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class PcieDevice(ExternalizableAbstractModel):

    """PCI Device entity description

    :param cluster_ext_id: (:attr:`cluster_ext_id`) UUID of the cluster.
    :type cluster_ext_id: 
    
    
    :param host_ext_id: (:attr:`host_ext_id`) UUID of the host connected to the device
    :type host_ext_id: 
    
    
    :param state: (:attr:`state`) 
    :type state: 
    
    
    :param description: (:attr:`description`) Human readable device description
    :type description: 
    
    
    :param configuration: (:attr:`configuration`) 
    :type configuration: 
    
    
    :param owner_vm_ext_id: (:attr:`owner_vm_ext_id`) UUID of the VM attached to that device when state is UVM_ASSIGNED or UVM_RESERVED
    :type owner_vm_ext_id: 
    
    
    :param type: (:attr:`type`) 
    :type type: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_ext_id': 'str',
        'host_ext_id': 'str',
        'state': 'clustermgmt.v4.ahv.config.PcieDeviceState',
        'description': 'str',
        'configuration': 'clustermgmt.v4.ahv.config.PcieDeviceConfiguration',
        'owner_vm_ext_id': 'str',
        'type': 'clustermgmt.v4.ahv.config.PcieDeviceType',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_ext_id': 'clusterExtId',
        'host_ext_id': 'hostExtId',
        'state': 'state',
        'description': 'description',
        'configuration': 'configuration',
        'owner_vm_ext_id': 'ownerVmExtId',
        'type': 'type',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_ext_id=None, host_ext_id=None, state=None, description=None, configuration=None, owner_vm_ext_id=None, type=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__cluster_ext_id = None
        self.__host_ext_id = None
        self.__state = None
        self.__description = None
        self.__configuration = None
        self.__owner_vm_ext_id = None
        self.__type = None
        self.discriminator = None
        if cluster_ext_id is not None:
            self.__cluster_ext_id = cluster_ext_id
        if host_ext_id is not None:
            self.__host_ext_id = host_ext_id
        if state is not None:
            self.__state = state
        if description is not None:
            self.__description = description
        if configuration is not None:
            self.__configuration = configuration
        if owner_vm_ext_id is not None:
            self.__owner_vm_ext_id = owner_vm_ext_id
        if type is not None:
            self.__type = type

    def _initialize_object_type(self):
        return 'clustermgmt.v4.ahv.config.PcieDevice'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def cluster_ext_id(self):
        """
        UUID of the cluster.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_ext_id

    @cluster_ext_id.setter
    def cluster_ext_id(self, cluster_ext_id):
        if cluster_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_ext_id = cluster_ext_id

    @property
    def host_ext_id(self):
        """
        UUID of the host connected to the device

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__host_ext_id

    @host_ext_id.setter
    def host_ext_id(self, host_ext_id):
        if host_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', host_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `host_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__host_ext_id = host_ext_id

    @property
    def state(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.ahv.config.PcieDeviceState`
        """  # noqa: E501
        return self.__state

    @state.setter
    def state(self, state):

        self.__state = state

    @property
    def description(self):
        """
        Human readable device description

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):

        self.__description = description

    @property
    def configuration(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.ahv.config.PcieDeviceConfiguration`
        """  # noqa: E501
        return self.__configuration

    @configuration.setter
    def configuration(self, configuration):

        self.__configuration = configuration

    @property
    def owner_vm_ext_id(self):
        """
        UUID of the VM attached to that device when state is UVM_ASSIGNED or UVM_RESERVED

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__owner_vm_ext_id

    @owner_vm_ext_id.setter
    def owner_vm_ext_id(self, owner_vm_ext_id):
        if owner_vm_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', owner_vm_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `owner_vm_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__owner_vm_ext_id = owner_vm_ext_id

    @property
    def type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.ahv.config.PcieDeviceType`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(PcieDevice, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PcieDevice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

