# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class BuildReference(object):

    """Build information details.

    :param build_type: (:attr:`build_type`) Software build type.
    :type build_type: 
    
    
    :param version: (:attr:`version`) Software version.
    :type version: 
    
    
    :param full_version: (:attr:`full_version`) Full name of software version.
    :type full_version: 
    
    
    :param commit_id: (:attr:`commit_id`) Commit Id used for version.
    :type commit_id: 
    
    
    :param short_commit_id: (:attr:`short_commit_id`) Short commit Id used for version.
    :type short_commit_id: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'build_type': 'str',
        'version': 'str',
        'full_version': 'str',
        'commit_id': 'str',
        'short_commit_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'build_type': 'buildType',
        'version': 'version',
        'full_version': 'fullVersion',
        'commit_id': 'commitId',
        'short_commit_id': 'shortCommitId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, build_type=None, version=None, full_version=None, commit_id=None, short_commit_id=None, *args, **kwargs):  # noqa: E501
        self.__build_type = None
        self.__version = None
        self.__full_version = None
        self.__commit_id = None
        self.__short_commit_id = None
        self.discriminator = None
        if build_type is not None:
            self.__build_type = build_type
        if version is not None:
            self.__version = version
        if full_version is not None:
            self.__full_version = full_version
        if commit_id is not None:
            self.__commit_id = commit_id
        if short_commit_id is not None:
            self.__short_commit_id = short_commit_id
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.BuildReference'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def build_type(self):
        """
        Software build type.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__build_type

    @build_type.setter
    def build_type(self, build_type):

        self.__build_type = build_type

    @property
    def version(self):
        """
        Software version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__version

    @version.setter
    def version(self, version):

        self.__version = version

    @property
    def full_version(self):
        """
        Full name of software version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__full_version

    @full_version.setter
    def full_version(self, full_version):

        self.__full_version = full_version

    @property
    def commit_id(self):
        """
        Commit Id used for version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__commit_id

    @commit_id.setter
    def commit_id(self, commit_id):

        self.__commit_id = commit_id

    @property
    def short_commit_id(self):
        """
        Short commit Id used for version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__short_commit_id

    @short_commit_id.setter
    def short_commit_id(self, short_commit_id):

        self.__short_commit_id = short_commit_id

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(BuildReference, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BuildReference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

