# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterConfigReference import ClusterConfigReference  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterNetworkReference import ClusterNetworkReference  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NodeReference import NodeReference  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.UpgradeStatus import UpgradeStatus  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class Cluster(ExternalizableAbstractModel):

    """Cluster entity with its attributes.

    :param name: (:attr:`name`) Cluster name. This is part of payload for both cluster create & update operations.
    :type name: 
     max=75 chars
    
    :param nodes: (:attr:`nodes`) 
    :type nodes: 
    
    
    :param config: (:attr:`config`) 
    :type config: 
    
    
    :param network: (:attr:`network`) 
    :type network: 
    
    
    :param upgrade_status: (:attr:`upgrade_status`) 
    :type upgrade_status: 
    
    
    :param vm_count: (:attr:`vm_count`) Number of VMs.
    :type vm_count: 
    
    
    :param inefficient_vm_count: (:attr:`inefficient_vm_count`) Number of inefficient VMs.
    :type inefficient_vm_count: 
    
    
    :param container_name: (:attr:`container_name`) The name of the default container created as part of cluster creation. This is part of payload for cluster create operation only.
    :type container_name: 
     max=64 chars
    
    :param categories: (:attr:`categories`) List of categories associated to the PE cluster.
    :type categories: 
    
    
    :param cluster_profile_ext_id: (:attr:`cluster_profile_ext_id`) UUID of the cluster profile.
    :type cluster_profile_ext_id: 
    
    
    :param backup_eligibility_score: (:attr:`backup_eligibility_score`) Score to indicate how much cluster is eligible for storing domain manager backup.
    :type backup_eligibility_score: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'nodes': 'clustermgmt.v4.config.NodeReference',
        'config': 'clustermgmt.v4.config.ClusterConfigReference',
        'network': 'clustermgmt.v4.config.ClusterNetworkReference',
        'upgrade_status': 'clustermgmt.v4.config.UpgradeStatus',
        'vm_count': 'int',
        'inefficient_vm_count': 'int',
        'container_name': 'str',
        'categories': 'list[str]',
        'cluster_profile_ext_id': 'str',
        'backup_eligibility_score': 'int',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'nodes': 'nodes',
        'config': 'config',
        'network': 'network',
        'upgrade_status': 'upgradeStatus',
        'vm_count': 'vmCount',
        'inefficient_vm_count': 'inefficientVmCount',
        'container_name': 'containerName',
        'categories': 'categories',
        'cluster_profile_ext_id': 'clusterProfileExtId',
        'backup_eligibility_score': 'backupEligibilityScore',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, nodes=None, config=None, network=None, upgrade_status=None, vm_count=None, inefficient_vm_count=None, container_name=None, categories=None, cluster_profile_ext_id=None, backup_eligibility_score=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__nodes = None
        self.__config = None
        self.__network = None
        self.__upgrade_status = None
        self.__vm_count = None
        self.__inefficient_vm_count = None
        self.__container_name = None
        self.__categories = None
        self.__cluster_profile_ext_id = None
        self.__backup_eligibility_score = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if nodes is not None:
            self.__nodes = nodes
        if config is not None:
            self.__config = config
        if network is not None:
            self.__network = network
        if upgrade_status is not None:
            self.__upgrade_status = upgrade_status
        if vm_count is not None:
            self.__vm_count = vm_count
        if inefficient_vm_count is not None:
            self.__inefficient_vm_count = inefficient_vm_count
        if container_name is not None:
            self.__container_name = container_name
        if categories is not None:
            self.__categories = categories
        if cluster_profile_ext_id is not None:
            self.__cluster_profile_ext_id = cluster_profile_ext_id
        if backup_eligibility_score is not None:
            self.__backup_eligibility_score = backup_eligibility_score

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.Cluster'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def name(self):
        """
        Cluster name. This is part of payload for both cluster create & update operations.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 75:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `75`")  # noqa: E501

        self.__name = name

    @property
    def nodes(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NodeReference`
        """  # noqa: E501
        return self.__nodes

    @nodes.setter
    def nodes(self, nodes):

        self.__nodes = nodes

    @property
    def config(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterConfigReference`
        """  # noqa: E501
        return self.__config

    @config.setter
    def config(self, config):

        self.__config = config

    @property
    def network(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterNetworkReference`
        """  # noqa: E501
        return self.__network

    @network.setter
    def network(self, network):

        self.__network = network

    @property
    def upgrade_status(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.UpgradeStatus`
        """  # noqa: E501
        return self.__upgrade_status

    @upgrade_status.setter
    def upgrade_status(self, upgrade_status):

        self.__upgrade_status = upgrade_status

    @property
    def vm_count(self):
        """
        Number of VMs.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__vm_count

    @vm_count.setter
    def vm_count(self, vm_count):

        self.__vm_count = vm_count

    @property
    def inefficient_vm_count(self):
        """
        Number of inefficient VMs.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__inefficient_vm_count

    @inefficient_vm_count.setter
    def inefficient_vm_count(self, inefficient_vm_count):

        self.__inefficient_vm_count = inefficient_vm_count

    @property
    def container_name(self):
        """
        The name of the default container created as part of cluster creation. This is part of payload for cluster create operation only.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__container_name

    @container_name.setter
    def container_name(self, container_name):
        if container_name is not None and len(container_name) > 64:
            raise ValueError("Invalid value for `container_name`, length must be less than or equal to `64`")  # noqa: E501

        self.__container_name = container_name

    @property
    def categories(self):
        """
        List of categories associated to the PE cluster.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__categories

    @categories.setter
    def categories(self, categories):

        self.__categories = categories

    @property
    def cluster_profile_ext_id(self):
        """
        UUID of the cluster profile.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_profile_ext_id

    @cluster_profile_ext_id.setter
    def cluster_profile_ext_id(self, cluster_profile_ext_id):
        if cluster_profile_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_profile_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_profile_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_profile_ext_id = cluster_profile_ext_id

    @property
    def backup_eligibility_score(self):
        """
        Score to indicate how much cluster is eligible for storing domain manager backup.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__backup_eligibility_score

    @backup_eligibility_score.setter
    def backup_eligibility_score(self, backup_eligibility_score):

        self.__backup_eligibility_score = backup_eligibility_score

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Cluster, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Cluster):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

