# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

class ControllerVmReference(object):

    """Host entity with its attributes.

    :param external_address: (:attr:`external_address`) 
    :type external_address: 
    
    
    :param backplane_address: (:attr:`backplane_address`) 
    :type backplane_address: 
    
    
    :param rdma_backplane_address: (:attr:`rdma_backplane_address`) RDMA backplane address.
    :type rdma_backplane_address: 
    
    
    :param nat_ip: (:attr:`nat_ip`) 
    :type nat_ip: 
    
    
    :param nat_port: (:attr:`nat_port`) NAT port.
    :type nat_port: 
    
    
    :param is_in_maintenance_mode: (:attr:`is_in_maintenance_mode`) Maintenance mode status.
    :type is_in_maintenance_mode: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'external_address': 'common.v1.config.IPAddress',
        'backplane_address': 'common.v1.config.IPAddress',
        'rdma_backplane_address': 'list[common.v1.config.IPAddress]',
        'nat_ip': 'common.v1.config.IPAddress',
        'nat_port': 'int',
        'is_in_maintenance_mode': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'external_address': 'externalAddress',
        'backplane_address': 'backplaneAddress',
        'rdma_backplane_address': 'rdmaBackplaneAddress',
        'nat_ip': 'natIp',
        'nat_port': 'natPort',
        'is_in_maintenance_mode': 'isInMaintenanceMode',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, external_address=None, backplane_address=None, rdma_backplane_address=None, nat_ip=None, nat_port=None, is_in_maintenance_mode=None, *args, **kwargs):  # noqa: E501
        self.__external_address = None
        self.__backplane_address = None
        self.__rdma_backplane_address = None
        self.__nat_ip = None
        self.__nat_port = None
        self.__is_in_maintenance_mode = None
        self.discriminator = None
        if external_address is not None:
            self.__external_address = external_address
        if backplane_address is not None:
            self.__backplane_address = backplane_address
        if rdma_backplane_address is not None:
            self.__rdma_backplane_address = rdma_backplane_address
        if nat_ip is not None:
            self.__nat_ip = nat_ip
        if nat_port is not None:
            self.__nat_port = nat_port
        if is_in_maintenance_mode is not None:
            self.__is_in_maintenance_mode = is_in_maintenance_mode
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.ControllerVmReference'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def external_address(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__external_address

    @external_address.setter
    def external_address(self, external_address):

        self.__external_address = external_address

    @property
    def backplane_address(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__backplane_address

    @backplane_address.setter
    def backplane_address(self, backplane_address):

        self.__backplane_address = backplane_address

    @property
    def rdma_backplane_address(self):
        """
        RDMA backplane address.

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__rdma_backplane_address

    @rdma_backplane_address.setter
    def rdma_backplane_address(self, rdma_backplane_address):

        self.__rdma_backplane_address = rdma_backplane_address

    @property
    def nat_ip(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__nat_ip

    @nat_ip.setter
    def nat_ip(self, nat_ip):

        self.__nat_ip = nat_ip

    @property
    def nat_port(self):
        """
        NAT port.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__nat_port

    @nat_port.setter
    def nat_port(self, nat_port):

        self.__nat_port = nat_port

    @property
    def is_in_maintenance_mode(self):
        """
        Maintenance mode status.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_in_maintenance_mode

    @is_in_maintenance_mode.setter
    def is_in_maintenance_mode(self, is_in_maintenance_mode):

        self.__is_in_maintenance_mode = is_in_maintenance_mode

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ControllerVmReference, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ControllerVmReference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

