# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class DataStore(ExternalizableAbstractModel):

    """

    :param datastore_name: (:attr:`datastore_name`) Name of the datastore.
    :type datastore_name: 
     max=255 chars
    
    :param container_ext_id: (:attr:`container_ext_id`) The external identifier of the Storage Container.
    :type container_ext_id: 
    
    
    :param container_name: (:attr:`container_name`) Name of the Storage Container. Note that the name of Storage Container should be unique in every cluster.
    :type container_name: 
     max=75 chars
    
    :param host_ext_id: (:attr:`host_ext_id`) The external identifier of the host for the datastore.
    :type host_ext_id: 
    
    
    :param host_ip_address: (:attr:`host_ip_address`) Host IP for datastore.
    :type host_ip_address: 
    
    
    :param capacity_bytes: (:attr:`capacity_bytes`) Maximum physical capacity of the Storage Container in bytes.
    :type capacity_bytes: 
    
    
    :param free_space_bytes: (:attr:`free_space_bytes`) The free space in the datastore.
    :type free_space_bytes: 
    
    
    :param vm_names: (:attr:`vm_names`) List of VM names in the datastore.
    :type vm_names: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'datastore_name': 'str',
        'container_ext_id': 'str',
        'container_name': 'str',
        'host_ext_id': 'str',
        'host_ip_address': 'str',
        'capacity_bytes': 'int',
        'free_space_bytes': 'int',
        'vm_names': 'list[str]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'datastore_name': 'datastoreName',
        'container_ext_id': 'containerExtId',
        'container_name': 'containerName',
        'host_ext_id': 'hostExtId',
        'host_ip_address': 'hostIpAddress',
        'capacity_bytes': 'capacityBytes',
        'free_space_bytes': 'freeSpaceBytes',
        'vm_names': 'vmNames',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, datastore_name=None, container_ext_id=None, container_name=None, host_ext_id=None, host_ip_address=None, capacity_bytes=None, free_space_bytes=None, vm_names=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__datastore_name = None
        self.__container_ext_id = None
        self.__container_name = None
        self.__host_ext_id = None
        self.__host_ip_address = None
        self.__capacity_bytes = None
        self.__free_space_bytes = None
        self.__vm_names = None
        self.discriminator = None
        if datastore_name is not None:
            self.__datastore_name = datastore_name
        if container_ext_id is not None:
            self.__container_ext_id = container_ext_id
        if container_name is not None:
            self.__container_name = container_name
        if host_ext_id is not None:
            self.__host_ext_id = host_ext_id
        if host_ip_address is not None:
            self.__host_ip_address = host_ip_address
        if capacity_bytes is not None:
            self.__capacity_bytes = capacity_bytes
        if free_space_bytes is not None:
            self.__free_space_bytes = free_space_bytes
        if vm_names is not None:
            self.__vm_names = vm_names

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.DataStore'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def datastore_name(self):
        """
        Name of the datastore.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__datastore_name

    @datastore_name.setter
    def datastore_name(self, datastore_name):
        if datastore_name is not None and len(datastore_name) > 255:
            raise ValueError("Invalid value for `datastore_name`, length must be less than or equal to `255`")  # noqa: E501

        self.__datastore_name = datastore_name

    @property
    def container_ext_id(self):
        """
        The external identifier of the Storage Container.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__container_ext_id

    @container_ext_id.setter
    def container_ext_id(self, container_ext_id):
        if container_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', container_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `container_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__container_ext_id = container_ext_id

    @property
    def container_name(self):
        """
        Name of the Storage Container. Note that the name of Storage Container should be unique in every cluster.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__container_name

    @container_name.setter
    def container_name(self, container_name):
        if container_name is not None and len(container_name) > 75:
            raise ValueError("Invalid value for `container_name`, length must be less than or equal to `75`")  # noqa: E501

        self.__container_name = container_name

    @property
    def host_ext_id(self):
        """
        The external identifier of the host for the datastore.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__host_ext_id

    @host_ext_id.setter
    def host_ext_id(self, host_ext_id):
        if host_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', host_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `host_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__host_ext_id = host_ext_id

    @property
    def host_ip_address(self):
        """
        Host IP for datastore.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__host_ip_address

    @host_ip_address.setter
    def host_ip_address(self, host_ip_address):
        if host_ip_address is not None and not re.search('#\/components\/schemas\/common.v1.r0.config.IPAddressOrFQDN', host_ip_address):  # noqa: E501
            raise ValueError(r"Invalid value for `host_ip_address`, must be a follow pattern or equal to `/#\/components\/schemas\/common.v1.r0.config.IPAddressOrFQDN/`")  # noqa: E501

        self.__host_ip_address = host_ip_address

    @property
    def capacity_bytes(self):
        """
        Maximum physical capacity of the Storage Container in bytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__capacity_bytes

    @capacity_bytes.setter
    def capacity_bytes(self, capacity_bytes):

        self.__capacity_bytes = capacity_bytes

    @property
    def free_space_bytes(self):
        """
        The free space in the datastore.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__free_space_bytes

    @free_space_bytes.setter
    def free_space_bytes(self, free_space_bytes):

        self.__free_space_bytes = free_space_bytes

    @property
    def vm_names(self):
        """
        List of VM names in the datastore.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__vm_names

    @vm_names.setter
    def vm_names(self, vm_names):

        self.__vm_names = vm_names

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DataStore, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataStore):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

