# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterFaultToleranceRef import ClusterFaultToleranceRef  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.DomainAwarenessLevel import DomainAwarenessLevel  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.RedundancyStatusDetails import RedundancyStatusDetails  # noqa: F401,E501

class FaultToleranceState(object):

    """Fault tolerant state of cluster.

    :param current_max_fault_tolerance: (:attr:`current_max_fault_tolerance`) Maximum fault tolerance that is supported currently.
    :type current_max_fault_tolerance: 
    
    
    :param desired_max_fault_tolerance: (:attr:`desired_max_fault_tolerance`) Maximum fault tolerance desired.
    :type desired_max_fault_tolerance: 
    
    
    :param domain_awareness_level: (:attr:`domain_awareness_level`) 
    :type domain_awareness_level: 
    
    
    :param current_cluster_fault_tolerance: (:attr:`current_cluster_fault_tolerance`) 
    :type current_cluster_fault_tolerance: 
    
    
    :param desired_cluster_fault_tolerance: (:attr:`desired_cluster_fault_tolerance`) 
    :type desired_cluster_fault_tolerance: 
    
    
    :param redundancy_status: (:attr:`redundancy_status`) 
    :type redundancy_status: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'current_max_fault_tolerance': 'int',
        'desired_max_fault_tolerance': 'int',
        'domain_awareness_level': 'clustermgmt.v4.config.DomainAwarenessLevel',
        'current_cluster_fault_tolerance': 'clustermgmt.v4.config.ClusterFaultToleranceRef',
        'desired_cluster_fault_tolerance': 'clustermgmt.v4.config.ClusterFaultToleranceRef',
        'redundancy_status': 'clustermgmt.v4.config.RedundancyStatusDetails',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'current_max_fault_tolerance': 'currentMaxFaultTolerance',
        'desired_max_fault_tolerance': 'desiredMaxFaultTolerance',
        'domain_awareness_level': 'domainAwarenessLevel',
        'current_cluster_fault_tolerance': 'currentClusterFaultTolerance',
        'desired_cluster_fault_tolerance': 'desiredClusterFaultTolerance',
        'redundancy_status': 'redundancyStatus',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, current_max_fault_tolerance=None, desired_max_fault_tolerance=None, domain_awareness_level=None, current_cluster_fault_tolerance=None, desired_cluster_fault_tolerance=None, redundancy_status=None, *args, **kwargs):  # noqa: E501
        self.__current_max_fault_tolerance = None
        self.__desired_max_fault_tolerance = None
        self.__domain_awareness_level = None
        self.__current_cluster_fault_tolerance = None
        self.__desired_cluster_fault_tolerance = None
        self.__redundancy_status = None
        self.discriminator = None
        if current_max_fault_tolerance is not None:
            self.__current_max_fault_tolerance = current_max_fault_tolerance
        if desired_max_fault_tolerance is not None:
            self.__desired_max_fault_tolerance = desired_max_fault_tolerance
        if domain_awareness_level is not None:
            self.__domain_awareness_level = domain_awareness_level
        if current_cluster_fault_tolerance is not None:
            self.__current_cluster_fault_tolerance = current_cluster_fault_tolerance
        if desired_cluster_fault_tolerance is not None:
            self.__desired_cluster_fault_tolerance = desired_cluster_fault_tolerance
        if redundancy_status is not None:
            self.__redundancy_status = redundancy_status
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.FaultToleranceState'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def current_max_fault_tolerance(self):
        """
        Maximum fault tolerance that is supported currently.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__current_max_fault_tolerance

    @current_max_fault_tolerance.setter
    def current_max_fault_tolerance(self, current_max_fault_tolerance):

        self.__current_max_fault_tolerance = current_max_fault_tolerance

    @property
    def desired_max_fault_tolerance(self):
        """
        Maximum fault tolerance desired.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__desired_max_fault_tolerance

    @desired_max_fault_tolerance.setter
    def desired_max_fault_tolerance(self, desired_max_fault_tolerance):

        self.__desired_max_fault_tolerance = desired_max_fault_tolerance

    @property
    def domain_awareness_level(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.DomainAwarenessLevel`
        """  # noqa: E501
        return self.__domain_awareness_level

    @domain_awareness_level.setter
    def domain_awareness_level(self, domain_awareness_level):

        self.__domain_awareness_level = domain_awareness_level

    @property
    def current_cluster_fault_tolerance(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterFaultToleranceRef`
        """  # noqa: E501
        return self.__current_cluster_fault_tolerance

    @current_cluster_fault_tolerance.setter
    def current_cluster_fault_tolerance(self, current_cluster_fault_tolerance):

        self.__current_cluster_fault_tolerance = current_cluster_fault_tolerance

    @property
    def desired_cluster_fault_tolerance(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterFaultToleranceRef`
        """  # noqa: E501
        return self.__desired_cluster_fault_tolerance

    @desired_cluster_fault_tolerance.setter
    def desired_cluster_fault_tolerance(self, desired_cluster_fault_tolerance):

        self.__desired_cluster_fault_tolerance = desired_cluster_fault_tolerance

    @property
    def redundancy_status(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.RedundancyStatusDetails`
        """  # noqa: E501
        return self.__redundancy_status

    @redundancy_status.setter
    def redundancy_status(self, redundancy_status):

        self.__redundancy_status = redundancy_status

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(FaultToleranceState, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FaultToleranceState):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

