# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NetworkSwitchInterface import NetworkSwitchInterface  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class HostNic(ExternalizableAbstractModel):

    """Host NIC details.

    :param name: (:attr:`name`) Name of the host NIC.
    :type name: 
     max=64 chars
    
    :param host_description: (:attr:`host_description`) Host description.
    :type host_description: 
    
    
    :param mac_address: (:attr:`mac_address`) Host Mac address.
    :type mac_address: 
    
    
    :param ipv4_addresses: (:attr:`ipv4_addresses`) List of IPv4 addresses associated with the NIC entity for the network connection.
    :type ipv4_addresses: 
    
    
    :param ipv6_addresses: (:attr:`ipv6_addresses`) List of IPv6 addresses associated with the NIC entity for the network connection.
    :type ipv6_addresses: 
    
    
    :param interface_status: (:attr:`interface_status`) Operational status of the interface to the port associated with the NIC entity.
    :type interface_status: 
    
    
    :param is_dhcp_enabled: (:attr:`is_dhcp_enabled`) Status of DHCP protocol.
    :type is_dhcp_enabled: 
    
    
    :param link_speed_in_kbps: (:attr:`link_speed_in_kbps`) Link current speed in Kbps.
    :type link_speed_in_kbps: 
    
    
    :param mtu_in_bytes: (:attr:`mtu_in_bytes`) Maximum transmission unit in bytes.
    :type mtu_in_bytes: 
    
    
    :param node_uuid: (:attr:`node_uuid`) UUID of the host.
    :type node_uuid: 
    
    
    :param discovery_protocol: (:attr:`discovery_protocol`) Network discovery protocol (either LLDP or None).
    :type discovery_protocol: 
    
    
    :param switch_device_id: (:attr:`switch_device_id`) Switch device Id learned through the discovery protocol.
    :type switch_device_id: 
    
    
    :param switch_port_id: (:attr:`switch_port_id`) Switch port Id learned through the discovery protocol.
    :type switch_port_id: 
    
    
    :param switch_vendor_info: (:attr:`switch_vendor_info`) Switch vendor information learned through the discovery protocol.
    :type switch_vendor_info: 
    
    
    :param switch_vlan_id: (:attr:`switch_vlan_id`) Switch VLAN Id learned through the discovery protocol.
    :type switch_vlan_id: 
    
    
    :param switch_management_ip: (:attr:`switch_management_ip`) 
    :type switch_management_ip: 
    
    
    :param switch_mac_address: (:attr:`switch_mac_address`) Switch Mac address
    :type switch_mac_address: 
    
    
    :param attached_switch_interface_list: (:attr:`attached_switch_interface_list`) List of network switch interfaces attached to the host NIC.
    :type attached_switch_interface_list: 
    
    
    :param rx_ring_size_in_bytes: (:attr:`rx_ring_size_in_bytes`) Size of configured buffer (in bytes) to the port associated with NIC, storing the network packets received through the port.
    :type rx_ring_size_in_bytes: 
    
    
    :param tx_ring_size_in_bytes: (:attr:`tx_ring_size_in_bytes`) Size of configured buffer (in bytes) to the port associated with NIC, storing the network packets that would be transmitted through the port.
    :type tx_ring_size_in_bytes: 
    
    
    :param link_capacity_in_mbps: (:attr:`link_capacity_in_mbps`) Link max speed that can be configured in Mbps.
    :type link_capacity_in_mbps: 
    
    
    :param cluster_ext_id: (:attr:`cluster_ext_id`) UUID of the cluster to which the host NIC belongs.
    :type cluster_ext_id: 
    
    
    :param nic_profile_ext_id: (:attr:`nic_profile_ext_id`) NIC profile ID to which the host NIC is attached.
    :type nic_profile_ext_id: 
    
    
    :param supported_capabilities: (:attr:`supported_capabilities`) List of supported capabilities of the host NIC.
    :type supported_capabilities: 
    
    
    :param driver_version: (:attr:`driver_version`) Driver version of the host NIC.
    :type driver_version: 
    
    
    :param firmware_version: (:attr:`firmware_version`) Firmware version of the host NIC.
    :type firmware_version: 
    
    
    :param virtual_nic_ext_ids: (:attr:`virtual_nic_ext_ids`) List of virtual NICs UUIDs associated with the host NIC.
    :type virtual_nic_ext_ids: 
    
    
    :param pci_model_id: (:attr:`pci_model_id`) PCI model ID of the host NIC.
    :type pci_model_id: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'host_description': 'str',
        'mac_address': 'str',
        'ipv4_addresses': 'list[common.v1.config.IPAddress]',
        'ipv6_addresses': 'list[common.v1.config.IPAddress]',
        'interface_status': 'str',
        'is_dhcp_enabled': 'bool',
        'link_speed_in_kbps': 'int',
        'mtu_in_bytes': 'int',
        'node_uuid': 'str',
        'discovery_protocol': 'str',
        'switch_device_id': 'str',
        'switch_port_id': 'str',
        'switch_vendor_info': 'str',
        'switch_vlan_id': 'str',
        'switch_management_ip': 'common.v1.config.IPAddress',
        'switch_mac_address': 'str',
        'attached_switch_interface_list': 'list[clustermgmt.v4.config.NetworkSwitchInterface]',
        'rx_ring_size_in_bytes': 'int',
        'tx_ring_size_in_bytes': 'int',
        'link_capacity_in_mbps': 'int',
        'cluster_ext_id': 'str',
        'nic_profile_ext_id': 'str',
        'supported_capabilities': 'list[str]',
        'driver_version': 'str',
        'firmware_version': 'str',
        'virtual_nic_ext_ids': 'list[str]',
        'pci_model_id': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'host_description': 'hostDescription',
        'mac_address': 'macAddress',
        'ipv4_addresses': 'ipv4Addresses',
        'ipv6_addresses': 'ipv6Addresses',
        'interface_status': 'interfaceStatus',
        'is_dhcp_enabled': 'isDhcpEnabled',
        'link_speed_in_kbps': 'linkSpeedInKbps',
        'mtu_in_bytes': 'mtuInBytes',
        'node_uuid': 'nodeUuid',
        'discovery_protocol': 'discoveryProtocol',
        'switch_device_id': 'switchDeviceId',
        'switch_port_id': 'switchPortId',
        'switch_vendor_info': 'switchVendorInfo',
        'switch_vlan_id': 'switchVlanId',
        'switch_management_ip': 'switchManagementIp',
        'switch_mac_address': 'switchMacAddress',
        'attached_switch_interface_list': 'attachedSwitchInterfaceList',
        'rx_ring_size_in_bytes': 'rxRingSizeInBytes',
        'tx_ring_size_in_bytes': 'txRingSizeInBytes',
        'link_capacity_in_mbps': 'linkCapacityInMbps',
        'cluster_ext_id': 'clusterExtId',
        'nic_profile_ext_id': 'nicProfileExtId',
        'supported_capabilities': 'supportedCapabilities',
        'driver_version': 'driverVersion',
        'firmware_version': 'firmwareVersion',
        'virtual_nic_ext_ids': 'virtualNicExtIds',
        'pci_model_id': 'pciModelId',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, host_description=None, mac_address=None, ipv4_addresses=None, ipv6_addresses=None, interface_status=None, is_dhcp_enabled=None, link_speed_in_kbps=None, mtu_in_bytes=None, node_uuid=None, discovery_protocol=None, switch_device_id=None, switch_port_id=None, switch_vendor_info=None, switch_vlan_id=None, switch_management_ip=None, switch_mac_address=None, attached_switch_interface_list=None, rx_ring_size_in_bytes=None, tx_ring_size_in_bytes=None, link_capacity_in_mbps=None, cluster_ext_id=None, nic_profile_ext_id=None, supported_capabilities=None, driver_version=None, firmware_version=None, virtual_nic_ext_ids=None, pci_model_id=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__host_description = None
        self.__mac_address = None
        self.__ipv4_addresses = None
        self.__ipv6_addresses = None
        self.__interface_status = None
        self.__is_dhcp_enabled = None
        self.__link_speed_in_kbps = None
        self.__mtu_in_bytes = None
        self.__node_uuid = None
        self.__discovery_protocol = None
        self.__switch_device_id = None
        self.__switch_port_id = None
        self.__switch_vendor_info = None
        self.__switch_vlan_id = None
        self.__switch_management_ip = None
        self.__switch_mac_address = None
        self.__attached_switch_interface_list = None
        self.__rx_ring_size_in_bytes = None
        self.__tx_ring_size_in_bytes = None
        self.__link_capacity_in_mbps = None
        self.__cluster_ext_id = None
        self.__nic_profile_ext_id = None
        self.__supported_capabilities = None
        self.__driver_version = None
        self.__firmware_version = None
        self.__virtual_nic_ext_ids = None
        self.__pci_model_id = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if host_description is not None:
            self.__host_description = host_description
        if mac_address is not None:
            self.__mac_address = mac_address
        if ipv4_addresses is not None:
            self.__ipv4_addresses = ipv4_addresses
        if ipv6_addresses is not None:
            self.__ipv6_addresses = ipv6_addresses
        if interface_status is not None:
            self.__interface_status = interface_status
        if is_dhcp_enabled is not None:
            self.__is_dhcp_enabled = is_dhcp_enabled
        if link_speed_in_kbps is not None:
            self.__link_speed_in_kbps = link_speed_in_kbps
        if mtu_in_bytes is not None:
            self.__mtu_in_bytes = mtu_in_bytes
        if node_uuid is not None:
            self.__node_uuid = node_uuid
        if discovery_protocol is not None:
            self.__discovery_protocol = discovery_protocol
        if switch_device_id is not None:
            self.__switch_device_id = switch_device_id
        if switch_port_id is not None:
            self.__switch_port_id = switch_port_id
        if switch_vendor_info is not None:
            self.__switch_vendor_info = switch_vendor_info
        if switch_vlan_id is not None:
            self.__switch_vlan_id = switch_vlan_id
        if switch_management_ip is not None:
            self.__switch_management_ip = switch_management_ip
        if switch_mac_address is not None:
            self.__switch_mac_address = switch_mac_address
        if attached_switch_interface_list is not None:
            self.__attached_switch_interface_list = attached_switch_interface_list
        if rx_ring_size_in_bytes is not None:
            self.__rx_ring_size_in_bytes = rx_ring_size_in_bytes
        if tx_ring_size_in_bytes is not None:
            self.__tx_ring_size_in_bytes = tx_ring_size_in_bytes
        if link_capacity_in_mbps is not None:
            self.__link_capacity_in_mbps = link_capacity_in_mbps
        if cluster_ext_id is not None:
            self.__cluster_ext_id = cluster_ext_id
        if nic_profile_ext_id is not None:
            self.__nic_profile_ext_id = nic_profile_ext_id
        if supported_capabilities is not None:
            self.__supported_capabilities = supported_capabilities
        if driver_version is not None:
            self.__driver_version = driver_version
        if firmware_version is not None:
            self.__firmware_version = firmware_version
        if virtual_nic_ext_ids is not None:
            self.__virtual_nic_ext_ids = virtual_nic_ext_ids
        if pci_model_id is not None:
            self.__pci_model_id = pci_model_id

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.HostNic'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def name(self):
        """
        Name of the host NIC.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 64:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `64`")  # noqa: E501

        self.__name = name

    @property
    def host_description(self):
        """
        Host description.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__host_description

    @host_description.setter
    def host_description(self, host_description):

        self.__host_description = host_description

    @property
    def mac_address(self):
        """
        Host Mac address.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        if mac_address is not None and not re.search('^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$', mac_address):  # noqa: E501
            raise ValueError(r"Invalid value for `mac_address`, must be a follow pattern or equal to `/^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$/`")  # noqa: E501

        self.__mac_address = mac_address

    @property
    def ipv4_addresses(self):
        """
        List of IPv4 addresses associated with the NIC entity for the network connection.

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__ipv4_addresses

    @ipv4_addresses.setter
    def ipv4_addresses(self, ipv4_addresses):

        self.__ipv4_addresses = ipv4_addresses

    @property
    def ipv6_addresses(self):
        """
        List of IPv6 addresses associated with the NIC entity for the network connection.

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__ipv6_addresses

    @ipv6_addresses.setter
    def ipv6_addresses(self, ipv6_addresses):

        self.__ipv6_addresses = ipv6_addresses

    @property
    def interface_status(self):
        """
        Operational status of the interface to the port associated with the NIC entity.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__interface_status

    @interface_status.setter
    def interface_status(self, interface_status):

        self.__interface_status = interface_status

    @property
    def is_dhcp_enabled(self):
        """
        Status of DHCP protocol.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_dhcp_enabled

    @is_dhcp_enabled.setter
    def is_dhcp_enabled(self, is_dhcp_enabled):

        self.__is_dhcp_enabled = is_dhcp_enabled

    @property
    def link_speed_in_kbps(self):
        """
        Link current speed in Kbps.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__link_speed_in_kbps

    @link_speed_in_kbps.setter
    def link_speed_in_kbps(self, link_speed_in_kbps):

        self.__link_speed_in_kbps = link_speed_in_kbps

    @property
    def mtu_in_bytes(self):
        """
        Maximum transmission unit in bytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__mtu_in_bytes

    @mtu_in_bytes.setter
    def mtu_in_bytes(self, mtu_in_bytes):

        self.__mtu_in_bytes = mtu_in_bytes

    @property
    def node_uuid(self):
        """
        UUID of the host.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__node_uuid

    @node_uuid.setter
    def node_uuid(self, node_uuid):
        if node_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', node_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `node_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__node_uuid = node_uuid

    @property
    def discovery_protocol(self):
        """
        Network discovery protocol (either LLDP or None).

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__discovery_protocol

    @discovery_protocol.setter
    def discovery_protocol(self, discovery_protocol):

        self.__discovery_protocol = discovery_protocol

    @property
    def switch_device_id(self):
        """
        Switch device Id learned through the discovery protocol.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__switch_device_id

    @switch_device_id.setter
    def switch_device_id(self, switch_device_id):

        self.__switch_device_id = switch_device_id

    @property
    def switch_port_id(self):
        """
        Switch port Id learned through the discovery protocol.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__switch_port_id

    @switch_port_id.setter
    def switch_port_id(self, switch_port_id):

        self.__switch_port_id = switch_port_id

    @property
    def switch_vendor_info(self):
        """
        Switch vendor information learned through the discovery protocol.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__switch_vendor_info

    @switch_vendor_info.setter
    def switch_vendor_info(self, switch_vendor_info):

        self.__switch_vendor_info = switch_vendor_info

    @property
    def switch_vlan_id(self):
        """
        Switch VLAN Id learned through the discovery protocol.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__switch_vlan_id

    @switch_vlan_id.setter
    def switch_vlan_id(self, switch_vlan_id):

        self.__switch_vlan_id = switch_vlan_id

    @property
    def switch_management_ip(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__switch_management_ip

    @switch_management_ip.setter
    def switch_management_ip(self, switch_management_ip):

        self.__switch_management_ip = switch_management_ip

    @property
    def switch_mac_address(self):
        """
        Switch Mac address

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__switch_mac_address

    @switch_mac_address.setter
    def switch_mac_address(self, switch_mac_address):
        if switch_mac_address is not None and not re.search('^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$', switch_mac_address):  # noqa: E501
            raise ValueError(r"Invalid value for `switch_mac_address`, must be a follow pattern or equal to `/^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$/`")  # noqa: E501

        self.__switch_mac_address = switch_mac_address

    @property
    def attached_switch_interface_list(self):
        """
        List of network switch interfaces attached to the host NIC.

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NetworkSwitchInterface` ]
        """  # noqa: E501
        return self.__attached_switch_interface_list

    @attached_switch_interface_list.setter
    def attached_switch_interface_list(self, attached_switch_interface_list):

        self.__attached_switch_interface_list = attached_switch_interface_list

    @property
    def rx_ring_size_in_bytes(self):
        """
        Size of configured buffer (in bytes) to the port associated with NIC, storing the network packets received through the port.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__rx_ring_size_in_bytes

    @rx_ring_size_in_bytes.setter
    def rx_ring_size_in_bytes(self, rx_ring_size_in_bytes):

        self.__rx_ring_size_in_bytes = rx_ring_size_in_bytes

    @property
    def tx_ring_size_in_bytes(self):
        """
        Size of configured buffer (in bytes) to the port associated with NIC, storing the network packets that would be transmitted through the port.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__tx_ring_size_in_bytes

    @tx_ring_size_in_bytes.setter
    def tx_ring_size_in_bytes(self, tx_ring_size_in_bytes):

        self.__tx_ring_size_in_bytes = tx_ring_size_in_bytes

    @property
    def link_capacity_in_mbps(self):
        """
        Link max speed that can be configured in Mbps.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__link_capacity_in_mbps

    @link_capacity_in_mbps.setter
    def link_capacity_in_mbps(self, link_capacity_in_mbps):

        self.__link_capacity_in_mbps = link_capacity_in_mbps

    @property
    def cluster_ext_id(self):
        """
        UUID of the cluster to which the host NIC belongs.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_ext_id

    @cluster_ext_id.setter
    def cluster_ext_id(self, cluster_ext_id):
        if cluster_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_ext_id = cluster_ext_id

    @property
    def nic_profile_ext_id(self):
        """
        NIC profile ID to which the host NIC is attached.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__nic_profile_ext_id

    @nic_profile_ext_id.setter
    def nic_profile_ext_id(self, nic_profile_ext_id):
        if nic_profile_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', nic_profile_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `nic_profile_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__nic_profile_ext_id = nic_profile_ext_id

    @property
    def supported_capabilities(self):
        """
        List of supported capabilities of the host NIC.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__supported_capabilities

    @supported_capabilities.setter
    def supported_capabilities(self, supported_capabilities):

        self.__supported_capabilities = supported_capabilities

    @property
    def driver_version(self):
        """
        Driver version of the host NIC.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__driver_version

    @driver_version.setter
    def driver_version(self, driver_version):

        self.__driver_version = driver_version

    @property
    def firmware_version(self):
        """
        Firmware version of the host NIC.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):

        self.__firmware_version = firmware_version

    @property
    def virtual_nic_ext_ids(self):
        """
        List of virtual NICs UUIDs associated with the host NIC.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__virtual_nic_ext_ids

    @virtual_nic_ext_ids.setter
    def virtual_nic_ext_ids(self, virtual_nic_ext_ids):

        self.__virtual_nic_ext_ids = virtual_nic_ext_ids

    @property
    def pci_model_id(self):
        """
        PCI model ID of the host NIC.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__pci_model_id

    @pci_model_id.setter
    def pci_model_id(self, pci_model_id):

        self.__pci_model_id = pci_model_id

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(HostNic, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HostNic):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

