# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.HypervisorType import HypervisorType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NodeLuksStatus import NodeLuksStatus  # noqa: F401,E501

class HypervisorUploadNodeListItem(object):

    """Individual node item details for checking whether hypervisor ISO upload is required or not.

    :param node_uuid: (:attr:`node_uuid`) UUID of the host.
    :type node_uuid: 
    
    
    :param hypervisor_version: (:attr:`hypervisor_version`) Host version of the node.
    :type hypervisor_version: 
    
    
    :param nos_version: (:attr:`nos_version`) NOS software version of a node.
    :type nos_version: 
    
    
    :param model: (:attr:`model`) Rackable unit model type.
    :type model: 
    
    
    :param block_id: (:attr:`block_id`) Rackable unit Id in which node resides.
    :type block_id: 
    
    
    :param is_light_compute: (:attr:`is_light_compute`) Indicates whether the node is light compute or not.
    :type is_light_compute: 
    
    
    :param hypervisor_type: (:attr:`hypervisor_type`) 
    :type hypervisor_type: 
    
    
    :param is_robo_mixed_hypervisor: (:attr:`is_robo_mixed_hypervisor`) Indicates whether the hypervisor is robo mixed or not.
    :type is_robo_mixed_hypervisor: 
    
    
    :param is_minimum_compute_node: (:attr:`is_minimum_compute_node`) Indicates if node is minimum compute or not.
    :type is_minimum_compute_node: 
    
    
    :param luks_status: (:attr:`luks_status`) 
    :type luks_status: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'node_uuid': 'str',
        'hypervisor_version': 'str',
        'nos_version': 'str',
        'model': 'str',
        'block_id': 'str',
        'is_light_compute': 'bool',
        'hypervisor_type': 'clustermgmt.v4.config.HypervisorType',
        'is_robo_mixed_hypervisor': 'bool',
        'is_minimum_compute_node': 'bool',
        'luks_status': 'clustermgmt.v4.config.NodeLuksStatus',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'node_uuid': 'nodeUuid',
        'hypervisor_version': 'hypervisorVersion',
        'nos_version': 'nosVersion',
        'model': 'model',
        'block_id': 'blockId',
        'is_light_compute': 'isLightCompute',
        'hypervisor_type': 'hypervisorType',
        'is_robo_mixed_hypervisor': 'isRoboMixedHypervisor',
        'is_minimum_compute_node': 'isMinimumComputeNode',
        'luks_status': 'luksStatus',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, node_uuid=None, hypervisor_version=None, nos_version=None, model=None, block_id=None, is_light_compute=None, hypervisor_type=None, is_robo_mixed_hypervisor=None, is_minimum_compute_node=None, luks_status=None, *args, **kwargs):  # noqa: E501
        self.__node_uuid = None
        self.__hypervisor_version = None
        self.__nos_version = None
        self.__model = None
        self.__block_id = None
        self.__is_light_compute = None
        self.__hypervisor_type = None
        self.__is_robo_mixed_hypervisor = None
        self.__is_minimum_compute_node = None
        self.__luks_status = None
        self.discriminator = None
        if node_uuid is not None:
            self.__node_uuid = node_uuid
        if hypervisor_version is not None:
            self.__hypervisor_version = hypervisor_version
        if nos_version is not None:
            self.__nos_version = nos_version
        if model is not None:
            self.__model = model
        if block_id is not None:
            self.__block_id = block_id
        if is_light_compute is not None:
            self.__is_light_compute = is_light_compute
        if hypervisor_type is not None:
            self.__hypervisor_type = hypervisor_type
        if is_robo_mixed_hypervisor is not None:
            self.__is_robo_mixed_hypervisor = is_robo_mixed_hypervisor
        if is_minimum_compute_node is not None:
            self.__is_minimum_compute_node = is_minimum_compute_node
        if luks_status is not None:
            self.__luks_status = luks_status
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.HypervisorUploadNodeListItem'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def node_uuid(self):
        """
        UUID of the host.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__node_uuid

    @node_uuid.setter
    def node_uuid(self, node_uuid):
        if node_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', node_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `node_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__node_uuid = node_uuid

    @property
    def hypervisor_version(self):
        """
        Host version of the node.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__hypervisor_version

    @hypervisor_version.setter
    def hypervisor_version(self, hypervisor_version):

        self.__hypervisor_version = hypervisor_version

    @property
    def nos_version(self):
        """
        NOS software version of a node.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__nos_version

    @nos_version.setter
    def nos_version(self, nos_version):

        self.__nos_version = nos_version

    @property
    def model(self):
        """
        Rackable unit model type.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__model

    @model.setter
    def model(self, model):

        self.__model = model

    @property
    def block_id(self):
        """
        Rackable unit Id in which node resides.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__block_id

    @block_id.setter
    def block_id(self, block_id):

        self.__block_id = block_id

    @property
    def is_light_compute(self):
        """
        Indicates whether the node is light compute or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_light_compute

    @is_light_compute.setter
    def is_light_compute(self, is_light_compute):

        self.__is_light_compute = is_light_compute

    @property
    def hypervisor_type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.HypervisorType`
        """  # noqa: E501
        return self.__hypervisor_type

    @hypervisor_type.setter
    def hypervisor_type(self, hypervisor_type):

        self.__hypervisor_type = hypervisor_type

    @property
    def is_robo_mixed_hypervisor(self):
        """
        Indicates whether the hypervisor is robo mixed or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_robo_mixed_hypervisor

    @is_robo_mixed_hypervisor.setter
    def is_robo_mixed_hypervisor(self, is_robo_mixed_hypervisor):

        self.__is_robo_mixed_hypervisor = is_robo_mixed_hypervisor

    @property
    def is_minimum_compute_node(self):
        """
        Indicates if node is minimum compute or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_minimum_compute_node

    @is_minimum_compute_node.setter
    def is_minimum_compute_node(self, is_minimum_compute_node):

        self.__is_minimum_compute_node = is_minimum_compute_node

    @property
    def luks_status(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NodeLuksStatus`
        """  # noqa: E501
        return self.__luks_status

    @luks_status.setter
    def luks_status(self, luks_status):

        self.__luks_status = luks_status

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(HypervisorUploadNodeListItem, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HypervisorUploadNodeListItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

