# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ManagementServerType import ManagementServerType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

class ManagementServerRef(object):

    """Management server information.

    :param ip: (:attr:`ip`) 
    :type ip: 
    
    
    :param type: (:attr:`type`) 
    :type type: 
    
    
    :param is_drs_enabled: (:attr:`is_drs_enabled`) Indicates whether it is DRS enabled or not.
    :type is_drs_enabled: 
    
    
    :param is_registered: (:attr:`is_registered`) Indicates whether it is registered or not.
    :type is_registered: 
    
    
    :param is_in_use: (:attr:`is_in_use`) Indicates whether the host is managed by an entity or not.
    :type is_in_use: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'ip': 'common.v1.config.IPAddress',
        'type': 'clustermgmt.v4.config.ManagementServerType',
        'is_drs_enabled': 'bool',
        'is_registered': 'bool',
        'is_in_use': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'ip': 'ip',
        'type': 'type',
        'is_drs_enabled': 'isDrsEnabled',
        'is_registered': 'isRegistered',
        'is_in_use': 'isInUse',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, ip=None, type=None, is_drs_enabled=None, is_registered=None, is_in_use=None, *args, **kwargs):  # noqa: E501
        self.__ip = None
        self.__type = None
        self.__is_drs_enabled = None
        self.__is_registered = None
        self.__is_in_use = None
        self.discriminator = None
        if ip is not None:
            self.__ip = ip
        if type is not None:
            self.__type = type
        if is_drs_enabled is not None:
            self.__is_drs_enabled = is_drs_enabled
        if is_registered is not None:
            self.__is_registered = is_registered
        if is_in_use is not None:
            self.__is_in_use = is_in_use
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.ManagementServerRef'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def ip(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__ip

    @ip.setter
    def ip(self, ip):

        self.__ip = ip

    @property
    def type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ManagementServerType`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    @property
    def is_drs_enabled(self):
        """
        Indicates whether it is DRS enabled or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_drs_enabled

    @is_drs_enabled.setter
    def is_drs_enabled(self, is_drs_enabled):

        self.__is_drs_enabled = is_drs_enabled

    @property
    def is_registered(self):
        """
        Indicates whether it is registered or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_registered

    @is_registered.setter
    def is_registered(self, is_registered):

        self.__is_registered = is_registered

    @property
    def is_in_use(self):
        """
        Indicates whether the host is managed by an entity or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_in_use

    @is_in_use.setter
    def is_in_use(self, is_in_use):

        self.__is_in_use = is_in_use

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ManagementServerRef, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ManagementServerRef):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

