# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

class NonMigratableVmInfo(object):

    """Non-migratable VM details.

    :param vm_name: (:attr:`vm_name`) Name of the VM.
    :type vm_name: 
     max=64 chars
    
    :param vm_uuid: (:attr:`vm_uuid`) UUID of the VM.
    :type vm_uuid: 
    
    
    :param non_migratable_vm_reason: (:attr:`non_migratable_vm_reason`) Reason for a VM to be non-migratable.
    :type non_migratable_vm_reason: 
    
    
    :param host_ip: (:attr:`host_ip`) 
    :type host_ip: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'vm_name': 'str',
        'vm_uuid': 'str',
        'non_migratable_vm_reason': 'str',
        'host_ip': 'common.v1.config.IPAddress',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'vm_name': 'vmName',
        'vm_uuid': 'vmUuid',
        'non_migratable_vm_reason': 'nonMigratableVmReason',
        'host_ip': 'hostIp',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, vm_name=None, vm_uuid=None, non_migratable_vm_reason=None, host_ip=None, *args, **kwargs):  # noqa: E501
        self.__vm_name = None
        self.__vm_uuid = None
        self.__non_migratable_vm_reason = None
        self.__host_ip = None
        self.discriminator = None
        if vm_name is not None:
            self.__vm_name = vm_name
        if vm_uuid is not None:
            self.__vm_uuid = vm_uuid
        if non_migratable_vm_reason is not None:
            self.__non_migratable_vm_reason = non_migratable_vm_reason
        if host_ip is not None:
            self.__host_ip = host_ip
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.NonMigratableVmInfo'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def vm_name(self):
        """
        Name of the VM.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__vm_name

    @vm_name.setter
    def vm_name(self, vm_name):
        if vm_name is not None and len(vm_name) > 64:
            raise ValueError("Invalid value for `vm_name`, length must be less than or equal to `64`")  # noqa: E501

        self.__vm_name = vm_name

    @property
    def vm_uuid(self):
        """
        UUID of the VM.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__vm_uuid

    @vm_uuid.setter
    def vm_uuid(self, vm_uuid):
        if vm_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', vm_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `vm_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__vm_uuid = vm_uuid

    @property
    def non_migratable_vm_reason(self):
        """
        Reason for a VM to be non-migratable.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__non_migratable_vm_reason

    @non_migratable_vm_reason.setter
    def non_migratable_vm_reason(self, non_migratable_vm_reason):

        self.__non_migratable_vm_reason = non_migratable_vm_reason

    @property
    def host_ip(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__host_ip

    @host_ip.setter
    def host_ip(self, host_ip):

        self.__host_ip = host_ip

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NonMigratableVmInfo, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NonMigratableVmInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

