# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectedEntity import ProtectedEntity  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectionState import ProtectionState  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectionTarget import ProtectionTarget  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.error.AppMessage import AppMessage  # noqa: F401,E501

class ProtectionInfo(object):

    """Protection details for a cluster.

    :param cluster_ext_id: (:attr:`cluster_ext_id`) UUID for a cluster
    :type cluster_ext_id: 
    
    
    :param target_protection_state: (:attr:`target_protection_state`) 
    :type target_protection_state: 
    
    
    :param protection_state: (:attr:`protection_state`) 
    :type protection_state: 
    
    
    :param protection_target: (:attr:`protection_target`) 
    :type protection_target: 
    
    
    :param protection_rpo_minutes: (:attr:`protection_rpo_minutes`) Recovery point objective for protecting a cluster. The value determines the frequency of snapshots.
    :type protection_rpo_minutes: 
    
     min=60, max=360
    :param protected_entities: (:attr:`protected_entities`) 
    :type protected_entities: 
    
    
    :param failure_reason: (:attr:`failure_reason`) 
    :type failure_reason: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_ext_id': 'str',
        'target_protection_state': 'clustermgmt.v4.config.ProtectionState',
        'protection_state': 'clustermgmt.v4.config.ProtectionState',
        'protection_target': 'clustermgmt.v4.config.ProtectionTarget',
        'protection_rpo_minutes': 'int',
        'protected_entities': 'list[clustermgmt.v4.config.ProtectedEntity]',
        'failure_reason': 'clustermgmt.v4.error.AppMessage',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_ext_id': 'clusterExtId',
        'target_protection_state': 'targetProtectionState',
        'protection_state': 'protectionState',
        'protection_target': 'protectionTarget',
        'protection_rpo_minutes': 'protectionRpoMinutes',
        'protected_entities': 'protectedEntities',
        'failure_reason': 'failureReason',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_ext_id=None, target_protection_state=None, protection_state=None, protection_target=None, protection_rpo_minutes=None, protected_entities=None, failure_reason=None, *args, **kwargs):  # noqa: E501
        self.__cluster_ext_id = None
        self.__target_protection_state = None
        self.__protection_state = None
        self.__protection_target = None
        self.__protection_rpo_minutes = None
        self.__protected_entities = None
        self.__failure_reason = None
        self.discriminator = None
        if cluster_ext_id is not None:
            self.__cluster_ext_id = cluster_ext_id
        if target_protection_state is not None:
            self.__target_protection_state = target_protection_state
        if protection_state is not None:
            self.__protection_state = protection_state
        if protection_target is not None:
            self.__protection_target = protection_target
        if protection_rpo_minutes is not None:
            self.__protection_rpo_minutes = protection_rpo_minutes
        if protected_entities is not None:
            self.__protected_entities = protected_entities
        if failure_reason is not None:
            self.__failure_reason = failure_reason
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.ProtectionInfo'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def cluster_ext_id(self):
        """
        UUID for a cluster

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_ext_id

    @cluster_ext_id.setter
    def cluster_ext_id(self, cluster_ext_id):
        if cluster_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_ext_id = cluster_ext_id

    @property
    def target_protection_state(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectionState`
        """  # noqa: E501
        return self.__target_protection_state

    @target_protection_state.setter
    def target_protection_state(self, target_protection_state):

        self.__target_protection_state = target_protection_state

    @property
    def protection_state(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectionState`
        """  # noqa: E501
        return self.__protection_state

    @protection_state.setter
    def protection_state(self, protection_state):

        self.__protection_state = protection_state

    @property
    def protection_target(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectionTarget`
        """  # noqa: E501
        return self.__protection_target

    @protection_target.setter
    def protection_target(self, protection_target):

        self.__protection_target = protection_target

    @property
    def protection_rpo_minutes(self):
        """
        Recovery point objective for protecting a cluster. The value determines the frequency of snapshots.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__protection_rpo_minutes

    @protection_rpo_minutes.setter
    def protection_rpo_minutes(self, protection_rpo_minutes):
        if protection_rpo_minutes is not None and protection_rpo_minutes > 360:  # noqa: E501
            raise ValueError("Invalid value for `protection_rpo_minutes`, must be a value less than or equal to `360`")  # noqa: E501
        if protection_rpo_minutes is not None and protection_rpo_minutes < 60:  # noqa: E501
            raise ValueError("Invalid value for `protection_rpo_minutes`, must be a value greater than or equal to `60`")  # noqa: E501

        self.__protection_rpo_minutes = protection_rpo_minutes

    @property
    def protected_entities(self):
        """
        

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ProtectedEntity` ]
        """  # noqa: E501
        return self.__protected_entities

    @protected_entities.setter
    def protected_entities(self, protected_entities):

        self.__protected_entities = protected_entities

    @property
    def failure_reason(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.error.AppMessage`
        """  # noqa: E501
        return self.__failure_reason

    @failure_reason.setter
    def failure_reason(self, failure_reason):

        self.__failure_reason = failure_reason

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ProtectionInfo, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProtectionInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

