# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.common.v1.config.IpRange import IpRange  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.networking.v4.aws.config.AwsSubnet import AwsSubnet  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.networking.v4.aws.config.CloudType import CloudType  # noqa: F401,E501

class Subnet(AwsSubnet):

    """Subnet details for a cluster.

    :param name: (:attr:`name`) Subnet name.
    :type name: 
    
    
    :param type: (:attr:`type`) Subnet type.
    :type type: 
    
    
    :param ip_pool_ranges: (:attr:`ip_pool_ranges`) IP address range
    :type ip_pool_ranges: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'type': 'str',
        'ip_pool_ranges': 'list[common.v1.config.IpRange]',
        'vpc_id': 'str',
        'annotation': 'str',
        'subnet_id': 'str',
        'cidr': 'str',
        'gateway_ip': 'str',
        'cloud_type': 'networking.v4.aws.config.CloudType',
        'availability_zone': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'ip_pool_ranges': 'ipPoolRanges',
        'vpc_id': 'vpcId',
        'annotation': 'annotation',
        'subnet_id': 'subnetId',
        'cidr': 'cidr',
        'gateway_ip': 'gatewayIp',
        'cloud_type': 'cloudType',
        'availability_zone': 'availabilityZone',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, type=None, ip_pool_ranges=None, vpc_id=None, annotation=None, subnet_id=None, cidr=None, gateway_ip=None, cloud_type=None, availability_zone=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        AwsSubnet.__init__(self, vpc_id, annotation, subnet_id, cidr, gateway_ip, cloud_type, availability_zone, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__type = None
        self.__ip_pool_ranges = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if type is not None:
            self.__type = type
        if ip_pool_ranges is not None:
            self.__ip_pool_ranges = ip_pool_ranges

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.Subnet'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def name(self):
        """
        Subnet name.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):

        self.__name = name

    @property
    def type(self):
        """
        Subnet type.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    @property
    def ip_pool_ranges(self):
        """
        IP address range

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IpRange` ]
        """  # noqa: E501
        return self.__ip_pool_ranges

    @ip_pool_ranges.setter
    def ip_pool_ranges(self, ip_pool_ranges):

        self.__ip_pool_ranges = ip_pool_ranges

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Subnet, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Subnet):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

