# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.PasswordStatus import PasswordStatus  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.SystemType import SystemType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.config.IPv4Address import IPv4Address  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class SystemUserPassword(ExternalizableAbstractModel):

    """Contains information about system user password.

    :param username: (:attr:`username`) Username.
    :type username: 
     max=199 chars
    
    :param host_ip: (:attr:`host_ip`) 
    :type host_ip: 
    
    
    :param cluster_ext_id: (:attr:`cluster_ext_id`) UUID of the cluster to which the host NIC belongs.
    :type cluster_ext_id: 
    
    
    :param last_update_time: (:attr:`last_update_time`) Timestamp of last password change.
    :type last_update_time: 
    
    
    :param expiry_time: (:attr:`expiry_time`) Expiry of a new password.
    :type expiry_time: 
    
    
    :param status: (:attr:`status`) 
    :type status: 
    
    
    :param system_type: (:attr:`system_type`) 
    :type system_type: 
    
    
    :param has_hsp_in_use: (:attr:`has_hsp_in_use`) Indicates whether the high-strength password is in use or not.
    :type has_hsp_in_use: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'username': 'str',
        'host_ip': 'common.v1.config.IPv4Address',
        'cluster_ext_id': 'str',
        'last_update_time': 'datetime',
        'expiry_time': 'datetime',
        'status': 'clustermgmt.v4.config.PasswordStatus',
        'system_type': 'clustermgmt.v4.config.SystemType',
        'has_hsp_in_use': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'username': 'username',
        'host_ip': 'hostIp',
        'cluster_ext_id': 'clusterExtId',
        'last_update_time': 'lastUpdateTime',
        'expiry_time': 'expiryTime',
        'status': 'status',
        'system_type': 'systemType',
        'has_hsp_in_use': 'hasHspInUse',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, username=None, host_ip=None, cluster_ext_id=None, last_update_time=None, expiry_time=None, status=None, system_type=None, has_hsp_in_use=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__username = None
        self.__host_ip = None
        self.__cluster_ext_id = None
        self.__last_update_time = None
        self.__expiry_time = None
        self.__status = None
        self.__system_type = None
        self.__has_hsp_in_use = None
        self.discriminator = None
        if username is not None:
            self.__username = username
        if host_ip is not None:
            self.__host_ip = host_ip
        if cluster_ext_id is not None:
            self.__cluster_ext_id = cluster_ext_id
        if last_update_time is not None:
            self.__last_update_time = last_update_time
        if expiry_time is not None:
            self.__expiry_time = expiry_time
        if status is not None:
            self.__status = status
        if system_type is not None:
            self.__system_type = system_type
        if has_hsp_in_use is not None:
            self.__has_hsp_in_use = has_hsp_in_use

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.SystemUserPassword'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def username(self):
        """
        Username.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__username

    @username.setter
    def username(self, username):
        if username is not None and len(username) > 199:
            raise ValueError("Invalid value for `username`, length must be less than or equal to `199`")  # noqa: E501

        self.__username = username

    @property
    def host_ip(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPv4Address`
        """  # noqa: E501
        return self.__host_ip

    @host_ip.setter
    def host_ip(self, host_ip):

        self.__host_ip = host_ip

    @property
    def cluster_ext_id(self):
        """
        UUID of the cluster to which the host NIC belongs.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_ext_id

    @cluster_ext_id.setter
    def cluster_ext_id(self, cluster_ext_id):
        if cluster_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_ext_id = cluster_ext_id

    @property
    def last_update_time(self):
        """
        Timestamp of last password change.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_update_time

    @last_update_time.setter
    def last_update_time(self, last_update_time):

        self.__last_update_time = last_update_time

    @property
    def expiry_time(self):
        """
        Expiry of a new password.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__expiry_time

    @expiry_time.setter
    def expiry_time(self, expiry_time):

        self.__expiry_time = expiry_time

    @property
    def status(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.PasswordStatus`
        """  # noqa: E501
        return self.__status

    @status.setter
    def status(self, status):

        self.__status = status

    @property
    def system_type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.SystemType`
        """  # noqa: E501
        return self.__system_type

    @system_type.setter
    def system_type(self, system_type):

        self.__system_type = system_type

    @property
    def has_hsp_in_use(self):
        """
        Indicates whether the high-strength password is in use or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__has_hsp_in_use

    @has_hsp_in_use.setter
    def has_hsp_in_use(self, has_hsp_in_use):

        self.__has_hsp_in_use = has_hsp_in_use

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SystemUserPassword, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemUserPassword):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

