# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterProjection import ClusterProjection  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.PasswordStatus import PasswordStatus  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.SystemType import SystemType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.SystemUserPassword import SystemUserPassword  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.config.IPv4Address import IPv4Address  # noqa: F401,E501

class SystemUserPasswordProjection(SystemUserPassword):

    """

    :param cluster_projection: (:attr:`cluster_projection`) 
    :type cluster_projection: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_projection': 'clustermgmt.v4.config.ClusterProjection',
        'username': 'str',
        'host_ip': 'common.v1.config.IPv4Address',
        'cluster_ext_id': 'str',
        'last_update_time': 'datetime',
        'expiry_time': 'datetime',
        'status': 'clustermgmt.v4.config.PasswordStatus',
        'system_type': 'clustermgmt.v4.config.SystemType',
        'has_hsp_in_use': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_projection': 'clusterProjection',
        'username': 'username',
        'host_ip': 'hostIp',
        'cluster_ext_id': 'clusterExtId',
        'last_update_time': 'lastUpdateTime',
        'expiry_time': 'expiryTime',
        'status': 'status',
        'system_type': 'systemType',
        'has_hsp_in_use': 'hasHspInUse',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_projection=None, username=None, host_ip=None, cluster_ext_id=None, last_update_time=None, expiry_time=None, status=None, system_type=None, has_hsp_in_use=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        SystemUserPassword.__init__(self, username, host_ip, cluster_ext_id, last_update_time, expiry_time, status, system_type, has_hsp_in_use, ext_id, links, tenant_id, *args, **kwargs)
        self.__cluster_projection = None
        self.discriminator = None
        if cluster_projection is not None:
            self.__cluster_projection = cluster_projection

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.SystemUserPasswordProjection'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def cluster_projection(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ClusterProjection`
        """  # noqa: E501
        return self.__cluster_projection

    @cluster_projection.setter
    def cluster_projection(self, cluster_projection):

        self.__cluster_projection = cluster_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SystemUserPasswordProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemUserPasswordProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

