# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_clustermgmt_py_client.models
from ntnx_clustermgmt_py_client.models.OneOfclustermgmt.v4.config.TaskResponseresponse import TaskResponseresponse  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.TaskResponseType import TaskResponseType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class TaskResponse(ExternalizableAbstractModel):

    """

    :param task_response_type: (:attr:`task_response_type`) 
    :type task_response_type: 
    
    
    :param response: (:attr:`response`) Task Response which is one of node-discovery, networking-details, hypervisor-upload, validate-bundle-info, non-compatible-cluster-reference  information.
    :type response: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'task_response_type': 'clustermgmt.v4.config.TaskResponseType',
        'response': 'OneOfclustermgmt.v4.config.TaskResponseresponse',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'task_response_type': 'taskResponseType',
        'response': 'response',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, task_response_type=None, response=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__task_response_type = None
        self.__response = None
        self.discriminator = None
        if task_response_type is not None:
            self.__task_response_type = task_response_type
        if response is not None:
            self.__response = response

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.TaskResponse'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def task_response_type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.TaskResponseType`
        """  # noqa: E501
        return self.__task_response_type

    @task_response_type.setter
    def task_response_type(self, task_response_type):

        self.__task_response_type = task_response_type

    @property
    def response(self):
        """
        Task Response which is one of node-discovery, networking-details, hypervisor-upload, validate-bundle-info, non-compatible-cluster-reference  information.

        :type:
                :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.UnconfigureNodeDetails` | 
                :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NodeNetworkingDetails` | 
                :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.HypervisorUploadInfo` | 
                :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.ValidateBundleInfo` | 
                :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.NonCompatibleClusterReference`
        """  # noqa: E501
        return self.__response

    @response.setter
    def response(self, response):

        self.__response = response

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_clustermgmt_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(TaskResponse, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaskResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

