# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.GpuType import GpuType  # noqa: F401,E501

class VirtualGpuConfig(object):

    """Virtual GPU configuration details.

    :param type: (:attr:`type`) 
    :type type: 
    
    
    :param device_id: (:attr:`device_id`) Device Id.
    :type device_id: 
    
    
    :param device_name: (:attr:`device_name`) Device name.
    :type device_name: 
     max=128 chars
    
    :param vendor_name: (:attr:`vendor_name`) Vendor name.
    :type vendor_name: 
     max=128 chars
    
    :param is_in_use: (:attr:`is_in_use`) GPU in use. (**Default** False)
    :type is_in_use: 
    
    
    :param sbdf: (:attr:`sbdf`) SBDF address.
    :type sbdf: 
     max=11 chars
    
    :param numa_node: (:attr:`numa_node`) NUMA node.
    :type numa_node: 
     max=2 chars
    
    :param assignable: (:attr:`assignable`) GPU assignable.
    :type assignable: 
    
    
    :param fraction: (:attr:`fraction`) GPU fraction.
    :type fraction: 
    
    
    :param guest_driver_version: (:attr:`guest_driver_version`) Guest driver version.
    :type guest_driver_version: 
     max=32 chars
    
    :param licenses: (:attr:`licenses`) GPU license list.
    :type licenses: 
    
    
    :param number_of_virtual_display_heads: (:attr:`number_of_virtual_display_heads`) Number of virtual display heads.
    :type number_of_virtual_display_heads: 
    
    
    :param frame_buffer_size_bytes: (:attr:`frame_buffer_size_bytes`) Frame buffer size in bytes.
    :type frame_buffer_size_bytes: 
    
    
    :param max_resolution: (:attr:`max_resolution`) Maximum resolution per display heads.
    :type max_resolution: 
     max=16 chars
    
    :param max_instances_per_vm: (:attr:`max_instances_per_vm`) Maximum instances allowed per VM.
    :type max_instances_per_vm: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'type': 'clustermgmt.v4.config.GpuType',
        'device_id': 'int',
        'device_name': 'str',
        'vendor_name': 'str',
        'is_in_use': 'bool',
        'sbdf': 'str',
        'numa_node': 'str',
        'assignable': 'int',
        'fraction': 'int',
        'guest_driver_version': 'str',
        'licenses': 'list[str]',
        'number_of_virtual_display_heads': 'int',
        'frame_buffer_size_bytes': 'int',
        'max_resolution': 'str',
        'max_instances_per_vm': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'type': 'type',
        'device_id': 'deviceId',
        'device_name': 'deviceName',
        'vendor_name': 'vendorName',
        'is_in_use': 'isInUse',
        'sbdf': 'sbdf',
        'numa_node': 'numaNode',
        'assignable': 'assignable',
        'fraction': 'fraction',
        'guest_driver_version': 'guestDriverVersion',
        'licenses': 'licenses',
        'number_of_virtual_display_heads': 'numberOfVirtualDisplayHeads',
        'frame_buffer_size_bytes': 'frameBufferSizeBytes',
        'max_resolution': 'maxResolution',
        'max_instances_per_vm': 'maxInstancesPerVm',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, type=None, device_id=None, device_name=None, vendor_name=None, is_in_use=False, sbdf=None, numa_node=None, assignable=None, fraction=None, guest_driver_version=None, licenses=None, number_of_virtual_display_heads=None, frame_buffer_size_bytes=None, max_resolution=None, max_instances_per_vm=None, *args, **kwargs):  # noqa: E501
        self.__type = None
        self.__device_id = None
        self.__device_name = None
        self.__vendor_name = None
        self.__is_in_use = None
        self.__sbdf = None
        self.__numa_node = None
        self.__assignable = None
        self.__fraction = None
        self.__guest_driver_version = None
        self.__licenses = None
        self.__number_of_virtual_display_heads = None
        self.__frame_buffer_size_bytes = None
        self.__max_resolution = None
        self.__max_instances_per_vm = None
        self.discriminator = None
        if type is not None:
            self.__type = type
        if device_id is not None:
            self.__device_id = device_id
        if device_name is not None:
            self.__device_name = device_name
        if vendor_name is not None:
            self.__vendor_name = vendor_name
        if is_in_use is not None:
            self.__is_in_use = is_in_use
        if sbdf is not None:
            self.__sbdf = sbdf
        if numa_node is not None:
            self.__numa_node = numa_node
        if assignable is not None:
            self.__assignable = assignable
        if fraction is not None:
            self.__fraction = fraction
        if guest_driver_version is not None:
            self.__guest_driver_version = guest_driver_version
        if licenses is not None:
            self.__licenses = licenses
        if number_of_virtual_display_heads is not None:
            self.__number_of_virtual_display_heads = number_of_virtual_display_heads
        if frame_buffer_size_bytes is not None:
            self.__frame_buffer_size_bytes = frame_buffer_size_bytes
        if max_resolution is not None:
            self.__max_resolution = max_resolution
        if max_instances_per_vm is not None:
            self.__max_instances_per_vm = max_instances_per_vm
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.VirtualGpuConfig'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.GpuType`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    @property
    def device_id(self):
        """
        Device Id.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__device_id

    @device_id.setter
    def device_id(self, device_id):

        self.__device_id = device_id

    @property
    def device_name(self):
        """
        Device name.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__device_name

    @device_name.setter
    def device_name(self, device_name):
        if device_name is not None and len(device_name) > 128:
            raise ValueError("Invalid value for `device_name`, length must be less than or equal to `128`")  # noqa: E501

        self.__device_name = device_name

    @property
    def vendor_name(self):
        """
        Vendor name.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__vendor_name

    @vendor_name.setter
    def vendor_name(self, vendor_name):
        if vendor_name is not None and len(vendor_name) > 128:
            raise ValueError("Invalid value for `vendor_name`, length must be less than or equal to `128`")  # noqa: E501

        self.__vendor_name = vendor_name

    @property
    def is_in_use(self):
        """
        GPU in use.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_in_use

    @is_in_use.setter
    def is_in_use(self, is_in_use):

        self.__is_in_use = is_in_use

    @property
    def sbdf(self):
        """
        SBDF address.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__sbdf

    @sbdf.setter
    def sbdf(self, sbdf):
        if sbdf is not None and len(sbdf) > 11:
            raise ValueError("Invalid value for `sbdf`, length must be less than or equal to `11`")  # noqa: E501

        self.__sbdf = sbdf

    @property
    def numa_node(self):
        """
        NUMA node.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__numa_node

    @numa_node.setter
    def numa_node(self, numa_node):
        if numa_node is not None and len(numa_node) > 2:
            raise ValueError("Invalid value for `numa_node`, length must be less than or equal to `2`")  # noqa: E501

        self.__numa_node = numa_node

    @property
    def assignable(self):
        """
        GPU assignable.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__assignable

    @assignable.setter
    def assignable(self, assignable):

        self.__assignable = assignable

    @property
    def fraction(self):
        """
        GPU fraction.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__fraction

    @fraction.setter
    def fraction(self, fraction):

        self.__fraction = fraction

    @property
    def guest_driver_version(self):
        """
        Guest driver version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__guest_driver_version

    @guest_driver_version.setter
    def guest_driver_version(self, guest_driver_version):
        if guest_driver_version is not None and len(guest_driver_version) > 32:
            raise ValueError("Invalid value for `guest_driver_version`, length must be less than or equal to `32`")  # noqa: E501

        self.__guest_driver_version = guest_driver_version

    @property
    def licenses(self):
        """
        GPU license list.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__licenses

    @licenses.setter
    def licenses(self, licenses):

        self.__licenses = licenses

    @property
    def number_of_virtual_display_heads(self):
        """
        Number of virtual display heads.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__number_of_virtual_display_heads

    @number_of_virtual_display_heads.setter
    def number_of_virtual_display_heads(self, number_of_virtual_display_heads):

        self.__number_of_virtual_display_heads = number_of_virtual_display_heads

    @property
    def frame_buffer_size_bytes(self):
        """
        Frame buffer size in bytes.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__frame_buffer_size_bytes

    @frame_buffer_size_bytes.setter
    def frame_buffer_size_bytes(self, frame_buffer_size_bytes):

        self.__frame_buffer_size_bytes = frame_buffer_size_bytes

    @property
    def max_resolution(self):
        """
        Maximum resolution per display heads.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__max_resolution

    @max_resolution.setter
    def max_resolution(self, max_resolution):
        if max_resolution is not None and len(max_resolution) > 16:
            raise ValueError("Invalid value for `max_resolution`, length must be less than or equal to `16`")  # noqa: E501

        self.__max_resolution = max_resolution

    @property
    def max_instances_per_vm(self):
        """
        Maximum instances allowed per VM.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__max_instances_per_vm

    @max_instances_per_vm.setter
    def max_instances_per_vm(self, max_instances_per_vm):

        self.__max_instances_per_vm = max_instances_per_vm

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VirtualGpuConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VirtualGpuConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

