# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.VcenterInfo import VcenterInfo  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.operations.HostMaintenanceCommonSpec import HostMaintenanceCommonSpec  # noqa: F401,E501

class EnterHostMaintenanceSpec(HostMaintenanceCommonSpec):

    """Property of the host to be put into maintenance mode.

    :param should_rollback_on_failure: (:attr:`should_rollback_on_failure`) A boolean value to indicate if the current workflow must initiate rollback workflow in case of failure. (**Default** True)
    :type should_rollback_on_failure: 
    
    
    :param should_shutdown_non_migratable_uvms: (:attr:`should_shutdown_non_migratable_uvms`) A boolean value to indicate if all non-migratable uvms must be shutdown. (**Default** False)
    :type should_shutdown_non_migratable_uvms: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'should_rollback_on_failure': 'bool',
        'should_shutdown_non_migratable_uvms': 'bool',
        'vcenter_info': 'clustermgmt.v4.config.VcenterInfo',
        'timeout_seconds': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'should_rollback_on_failure': 'shouldRollbackOnFailure',
        'should_shutdown_non_migratable_uvms': 'shouldShutdownNonMigratableUvms',
        'vcenter_info': 'vcenterInfo',
        'timeout_seconds': 'timeoutSeconds',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, should_rollback_on_failure=True, should_shutdown_non_migratable_uvms=False, vcenter_info=None, timeout_seconds=None, *args, **kwargs):  # noqa: E501
        HostMaintenanceCommonSpec.__init__(self, vcenter_info, timeout_seconds, *args, **kwargs)
        self.__should_rollback_on_failure = None
        self.__should_shutdown_non_migratable_uvms = None
        self.discriminator = None
        if should_rollback_on_failure is not None:
            self.__should_rollback_on_failure = should_rollback_on_failure
        if should_shutdown_non_migratable_uvms is not None:
            self.__should_shutdown_non_migratable_uvms = should_shutdown_non_migratable_uvms

    def _initialize_object_type(self):
        return 'clustermgmt.v4.operations.EnterHostMaintenanceSpec'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def should_rollback_on_failure(self):
        """
        A boolean value to indicate if the current workflow must initiate rollback workflow in case of failure.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__should_rollback_on_failure

    @should_rollback_on_failure.setter
    def should_rollback_on_failure(self, should_rollback_on_failure):

        self.__should_rollback_on_failure = should_rollback_on_failure

    @property
    def should_shutdown_non_migratable_uvms(self):
        """
        A boolean value to indicate if all non-migratable uvms must be shutdown.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__should_shutdown_non_migratable_uvms

    @should_shutdown_non_migratable_uvms.setter
    def should_shutdown_non_migratable_uvms(self, should_shutdown_non_migratable_uvms):

        self.__should_shutdown_non_migratable_uvms = should_shutdown_non_migratable_uvms

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(EnterHostMaintenanceSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EnterHostMaintenanceSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

