# coding: utf-8


"""
IGNORE:
    Nutanix Cluster Management APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.operations.RebootType import RebootType  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.operations.TargetRebootDomain import TargetRebootDomain  # noqa: F401,E501

class RollingRebootParams(object):

    """The payload to perform a rolling reboot operation.

    :param node_ext_id_list: (:attr:`node_ext_id_list`) List of Node UUIDs which are to be rebooted. This includes either Controller VM UUIDs or Host UUIDs.
    :type node_ext_id_list: 
    
    
    :param reboot_type: (:attr:`reboot_type`) 
    :type reboot_type: 
    
    
    :param reboot_description: (:attr:`reboot_description`) The description of the reboot operation to be performed.
    :type reboot_description: 
     max=64 chars
    
    :param target_reboot_domain: (:attr:`target_reboot_domain`) 
    :type target_reboot_domain: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'node_ext_id_list': 'list[str]',
        'reboot_type': 'clustermgmt.v4.operations.RebootType',
        'reboot_description': 'str',
        'target_reboot_domain': 'clustermgmt.v4.operations.TargetRebootDomain',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'node_ext_id_list': 'nodeExtIdList',
        'reboot_type': 'rebootType',
        'reboot_description': 'rebootDescription',
        'target_reboot_domain': 'targetRebootDomain',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, node_ext_id_list=None, reboot_type=None, reboot_description=None, target_reboot_domain=None, *args, **kwargs):  # noqa: E501
        self.__node_ext_id_list = None
        self.__reboot_type = None
        self.__reboot_description = None
        self.__target_reboot_domain = None
        self.discriminator = None
        if node_ext_id_list is not None:
            self.__node_ext_id_list = node_ext_id_list
        if reboot_type is not None:
            self.__reboot_type = reboot_type
        if reboot_description is not None:
            self.__reboot_description = reboot_description
        if target_reboot_domain is not None:
            self.__target_reboot_domain = target_reboot_domain
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.operations.RollingRebootParams'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def node_ext_id_list(self):
        """
        List of Node UUIDs which are to be rebooted. This includes either Controller VM UUIDs or Host UUIDs.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__node_ext_id_list

    @node_ext_id_list.setter
    def node_ext_id_list(self, node_ext_id_list):

        self.__node_ext_id_list = node_ext_id_list

    @property
    def reboot_type(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.operations.RebootType`
        """  # noqa: E501
        return self.__reboot_type

    @reboot_type.setter
    def reboot_type(self, reboot_type):

        self.__reboot_type = reboot_type

    @property
    def reboot_description(self):
        """
        The description of the reboot operation to be performed.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__reboot_description

    @reboot_description.setter
    def reboot_description(self, reboot_description):
        if reboot_description is not None and len(reboot_description) > 64:
            raise ValueError("Invalid value for `reboot_description`, length must be less than or equal to `64`")  # noqa: E501
        if reboot_description is not None and not re.search('^[A-Za-z0-9._-]+$', reboot_description):  # noqa: E501
            raise ValueError(r"Invalid value for `reboot_description`, must be a follow pattern or equal to `/^[A-Za-z0-9._-]+$/`")  # noqa: E501

        self.__reboot_description = reboot_description

    @property
    def target_reboot_domain(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.operations.TargetRebootDomain`
        """  # noqa: E501
        return self.__target_reboot_domain

    @target_reboot_domain.setter
    def target_reboot_domain(self, target_reboot_domain):

        self.__target_reboot_domain = target_reboot_domain

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RollingRebootParams, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RollingRebootParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

